# moog17scat
MOOG 2017 version with scattering

# UPDATE: Sep 1, 2022
Jen Sobeck has a new repository with updates to the code and more robustness checks.
I recommend new users use her version as it will likely be much better maintained than this repository.
https://github.com/jsobeck/MOOG-SCAT_basic_git

## UPDATE: Nov 16, 2021
I have updated `Synspec.f` following the comment below. I think it is better to change this than not.

Additionally, I have increased the hardcoded number of isotopes (it used to be 20, now it is 200).
Previously you would have been safe up to 40 isotopes if you did not use the MOOG GUI.

A question often asked is the differences between this and [Chris Sneden's](https://www.as.utexas.edu/~chris/moog.html) most recent [Nov 2019](https://www.as.utexas.edu/~chris/MOOGNOV2019.tar.gz) code.
In short, the recent update improved treatment of molecules (H2O, CO2), a linelist I/O setting that stopped automatic conversion of gf to loggf, and synthetic stellar populations (see [the documentation](https://www.as.utexas.edu/~chris/codes/WRITEnov2019.pdf)).
However, it does not have the updates described below, most notably not including scattering (despite the documentation saying otherwise).
So, if you are interested in similar science as me (abundances in metal-poor giants in optical wavelengths) I would recommend sticking to moog17scat.


## Comment: Apr 20, 2021.
I have been bothered by some of the "ringing" that happens at the ~0.005 normalized flux level when scattering is turned on, which didn't occur before in the 2011 Sobeck version. Some digging shows that in `Synspec.f` line 60, the wavelength differences threshold to recompute continuum quantities used to be 0.0001 instead of 0.001.
Changing this does appear to remove the ringing features, but it require many more calls to the continuum source function, so it's slower. For low S/N spectra this does not matter, but for high S/N spectra (around 100) you will want to change this parameter and recompile when computing synthetic spectra.

## IMPORTANT UPDATE: Sep 13, 2018.
A bug was introduced with the "trudamp" parameter in the 2014 refactoring.
It was turned on by default, rather than kept off.
This is now fixed to be off by default.
If you would like to turn trudamp on, use "trudamp 1" in the parameters.

There is also a typo bug in Trudamp.f that has been fixed for Ca3933 (thanks to Rana Ezzeddine for identifying the bug).

The bug only affected these specific lines (see Damping.f and Trudamp.f):
* Ca II (3933, 8498, 8542, 8662)
* CH (3693)
* Ca I (6717, 6318, 6343, 6361)
* Ca I autoionization (6318, 6343, 6361)

## IMPORTANT UPDATE: Aug 7, 2017.
I mistakenly introduced a bug causing problems with abfind. It is now fixed.

## MOOG
MOOG is a radiative transfer code for stellar abundances written by Chris Sneden.
http://www.as.utexas.edu/~chris/moog.html

The publicly available version of MOOG does not treat scattering properly for blue, metal-poor stars. This was fixed in 2011 by Jennifer Sobeck (Sobeck et al. 2011, AJ 141, 175),
and her version was widely distributed. A proper treatment of scattering is important to accurately compute abundances
of blue lines in metal-poor stars.
However, MOOG has since experienced several upgrades, with a big update coming in 2014. Scattering was not propagated to this version.

Here, I have taken the publicly available version of MOOG (from Feb 2017)
and patched in the code written by Jennifer Sobeck.
It can be turned on by setting "scat 1" in the configuration (batch.par) files.

WARNING:
Blends.f and Ewfind.f were not modified in the 2011 version I have. I may be mistaken, but it does not appear that they use Sobeck's scattering. I will eventually fix this, but this likely affected anything that used the blends driver for bluer lines (<4500A) in metal-poor stars.
UPDATE: I have learned that some versions of the scattering code did have Blends and Ewfind fixed. If you would like to check your version, you can do so by looking to see if "cdcalc_JS" is in Blends.f or Ewfind.f. If so, then you are probably good!

## Citation
If you use this code in a paper, please cite Sneden 1973 and Sobeck et al. 2011, AJ 141, 175.
I would also appreciate if you include a link to this page in a footnote (www.github.com/alexji/moog17scat).

## Installation Instructions
Instructions copied from http://www.as.utexas.edu/~chris/moog.html
* Download/extract or clone the repository (green button in top right)
  * If you are not sure which one to do, I recommend you clone. That way future updates or bugfixes can be downloaded easily.
  * https://help.github.com/articles/cloning-a-repository/
* Edit the `moogpath` variable in `Moog.f` and `Moogsilent.f` to suit your download location
* Compile MOOG with `make -f Makefile.xxx` where `xxx` is the setup that you want.
  * You will have to have a fortran compiler. `g77` is the one assumed by MOOG by default.
  * For Mac OS X, and old version of `g77` can be downloaded here: http://hpc.sourceforge.net/
  * However, `gfortran` is really the only fortran compiler supported on newer Mac laptops. So I recommend you use this instead.
  * I have edited `Makefile.maclapsilent` to work with `gfortran`. See that file if you want to see what compiler flags you should set to use `gfortran`.
* Ensure this new MOOG or MOOGSILENT is your default in your path.
  * You can edit your `.cshrc`, `.bashrc`, and/or `.bash_profile` to add this new directory.
  * For example, my `.bash_profile` has `export PATH="/Users/alexji/lib/moog17scat:$PATH"`
  * Check this by opening a new terminal and typing `which MOOGSILENT`. It should point to the correct place.

Some notes from Vini Placco about installing on Catalina.
```
I just compiled moog17scat on a fresh macOS Catalina installation. I had two small hiccups:

The gfortran I used at first came from gcc 10.2.0 (from homebrew). When I used this version, I got a few compilation errors on OpacHydrogen.f. Instead of messing with the code, I installed an earlier version of gfortran, which I knew worked:

brew install gcc@5

Then, on the Makefile.macdesk I have:

FC = /usr/local/Cellar/gcc\@5/5.5.0_4/bin/gfortran-5 -Wall -fno-range-check -w -ff2c
This compiled everything without errors or warnings.

I also had an error on the AQLIB library, and replacing: -L$(AQLIB) -laquaterm with -L$(AQLIB) -framework AquaTerm solved the problem.
```

Alex notes (2021-06-15):
```
The error Vini finds is in OpacHydrogen.f where a scalar is being passed into a variable that expects an array. Older fortran compilers had no problem with this (would throw a warning) but newer ones throw an error.

In newer versions of gfortran (v10 and above) you can get around this by adding this flag to the fortran compilation.
-fallow-argument-mismatch

e.g. change Makefile.maclapsilent to have:
FC = gfortran -fno-range-check -w -fallow-argument-mismatch

Thanks to Jandrie Rodriguez for helping debug this.
```

      subroutine nearly (numpass)
c******************************************************************************
c     This routine calculates the quantity 'kapnu0' for each line and       
c     each tau; this is the line opacity at line center.  When kapnu0 is 
c     multiplied by the voigt function, one gets the line opacity at an 
c     arbitrary wavelength.  Then, the Doppler factor 'dopp' and damping
c     parameter 'a' are also computed ('a' is done in a call to another
c     routine
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Dummy.com'
      real*8 xnum(100)
      integer numpass
      equivalence (xnum,dummy1)


c*****load in data for damping factors to be computed from the data
c     of Barklem, if desired
      if (numpass.eq.1 .and. dampingopt.eq.1) call gammabark


c*****Locate the atmosphere level where taulam is near 0.5
      if (numpass.eq.1 .or. numpass.eq.3) then
         call opacit (2,wave1(1))
         do i=1,ntau
            if (taulam(i) .ge. 0.5) go to 180
         enddo
180      jtau5 = i
      endif


c*****if reading in a new line list, do all lines (numpass=1); 
c     if iterating "abfind" on a species affected by mol. eq.,
c     do just that species (numpass=2); if doing a fake line, or
c     maybe one line for a special purpose, do just the first line 
c     in the "list" (numpass=3)
      if     (numpass .eq. 1) then
         j1 = 1
         j2 = nlines + nstrong
      elseif (numpass .eq. 2) then
         j1 = lim1line
         j2 = lim2line
      elseif (numpass .eq. 3) then
         j1 = 1
         j2 = 1
      endif


c*****now make the calculations:  set up some parameters
      do j=j1,j2
         ich = idint(charge(j) + 0.1)                    
         iatom = atom1(j) + 0.0001
         factoriso = 1.0
    
                  
c*****compute the Doppler factors
         if (numpass.eq.1 .or. numpass.eq.3) then
            do i=1,ntau
               dopp(j,i) = dsqrt(1.6631d8*t(i)/amass(j)+vturb(i)**2)
            enddo


c*****compute damping parameters in a separate routine
            call damping (j)
         endif


c*****either: compute lower state number densities for atomic lines;
c     q21 is the ion/neutral ratio, etc., and q is the ratio of the total
c     to the species of interest; do the Saha equation first, then
c     the Boltzmann equation
         if (iatom .lt. 100) then
            do i=1,ntau
               q21 = 4.825d15*u(iatom,2,i)/(u(iatom,1,i)*ne(i))*
     .               t(i)**1.5*dexp(-chi(j,1)/tkev(i)) 
               q32 = 4.825d15*u(iatom,3,i)/(u(iatom,2,i)*ne(i))*
     .               t(i)**1.5*dexp(-chi(j,2)/tkev(i)) 
               q43 = 4.825d15*u(iatom,4,i)/(u(iatom,3,i)*ne(i))*
     .               t(i)**1.5*dexp(-chi(j,3)/tkev(i)) 
               if (neq .ne. 0) then
                  do n=1,neq
                     if (iatom .eq. iorder(n)) then
                        xxnum = xamol(n,i)
                        if     (ich .eq. 1) then
                           q = 1.0
                        elseif (ich .eq. 2) then
                           q = 1.0/q21
                        elseif (ich .eq. 3) then
                           q = 1.0/(q21*q32) + 1.0/q32 + 1.0 + q43
                        endif
                        xnum(i) = xxnum/q*dexp(-e(j,1)/tkev(i))/
     .                            u(iatom,ich,i)   
                     endif
                  enddo
               endif
               if     (ich .eq. 1) then
                  q = 1.0 + q21 + q32*q21 + q43*q32*q21
               elseif (ich .eq. 2) then
                  q = 1.0/q21 + 1.0 + q32 + q43*q32
               elseif (ich .eq. 3) then
                  q = 1.0/(q21*q32) + 1.0/q32 + 1.0 + q43
               endif
               if (control .eq. 'abandy') then
                  xxab = xabund(iatom)*10**deltaabund
               else
                  xxab = xabund(iatom)
               endif
               xnum(i) = xxab*nhtot(i)/q*
     .                 dexp(-e(j,1)/tkev(i))/u(iatom,ich,i)
            enddo


c*****or: compute lower state number densities for molecular lines
         else
            call sunder(atom1(j),iaa,ibb)
            do n=1,neq
               if(iorder(n) .eq. iaa) ia = n
               if(iorder(n) .eq. ibb) ib = n
            enddo
            do i=1,ntau
               psipri = 
     .             1.38054d-16*t(i)*10.0**(d0(j)*theta(i)-13.670)*
     .             theta(i)**2.5/
     .             (rdmass(j)**1.5*u(iaa,1,i)*u(ibb,1,i)) 
               xnum(i) = dexp(-e(j,1)/tkev(i))*psipri*
     .                   xamol(ia,i)*xamol(ib,i)
            enddo
         endif


c*****finally, compute line opacities at line centers
         if (atom1(j)-float(iatom) .ge. 0.0) then
            do n=1,numiso
               if (atom1(j) .eq. isotope(n)) then
                  factoriso = isoabund(n,isorun)
               endif
            enddo
         endif
         do i=1,ntau
            kapnu0(j,i) = 2.65386d-2*xnum(i)*gf(j)*wave1(j)*1.0d-8/
     .                    dopp(j,i)*(1.0-dexp(-1.43879d8/
     .                    (wave1(j)*t(i))))/factoriso
         enddo
         strength(j) = kapnu0(j,jtau5)
      enddo


c*****output regular line information, and strong line information 
c     if appropriate; exit routine normally
      if (numpass.eq.1 .or. numpass.eq.3) then
         if (linprintopt .ge. 0) then
            if (dostrong .gt. 0) call lineinfo (2)
            call lineinfo (1)
         endif
      endif
      return


      end

      subroutine lineabund (abundin)
c******************************************************************************
c     This routine iteratively determines the abundance for a single line;
c     for ease and speed of computation the actual changes are done to 
c     gf-values, and then at the end the adjustment is made to input
c     abundance by the amount that the gf had to be changed
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'

  
      lim2 = lim1
      ncurve = 1


c*****find the c-o-g gf that matches the observed RW
      gf1(ncurve) = gf(lim1)
      rwlgobs = dlog10(width(lim1)/wave1(lim1))
      gfobs = gftab(ntabtot)
      do i=2,ntabtot
         if (rwtab(i) .gt. rwlgobs) then
            gfobs = gftab(i-1) + (gftab(i)-gftab(i-1))*
     .              (rwlgobs-rwtab(i-1))/(rwtab(i)-rwtab(i-1))
            go to 15
         endif
      enddo


c*****using the current gf, compute a line and find the c-o-g gf that matches
c*****the computed RW
15    call oneline (1)
      rwlgcal = dlog10(w(ncurve)/wave1(lim1))
      gfcal = gftab(ntabtot)
      do i=2,ntabtot
         if (rwtab(i) .gt. rwlgcal) then
            gfcal = gftab(i-1) + (gftab(i)-gftab(i-1))* 
     .              (rwlgcal-rwtab(i-1))/(rwtab(i)-rwtab(i-1))
            go to 20
         endif
      enddo

c*****are the observed and computed RWs too different?  if so, iterate 
c*****by adjusting the assumed gf, and recompute the line.
c*****for strong lines, the iterations are slowed down by using the
c*****square root of the proposed gf shift.
20    error = (w(ncurve)-width(lim1))/width(lim1)
      ratio = 10.**(gfobs-gfcal)
      ncurve = ncurve + 1
      if (dabs(error) .ge. 0.0015 .and. ncurve .lt. 20) then
         rwlcomp = dlog10(w(ncurve-1)/wave1(lim1))
         if (rwlcomp .gt. -4.7) then
            gf1(ncurve) = gf1(ncurve-1)*dsqrt(ratio)
            do i=1,ntau                                
               kapnu0(lim1,i) = kapnu0(lim1,i)*dsqrt(ratio)
            enddo
         else
            gf1(ncurve) = gf1(ncurve-1)*ratio
            do i=1,ntau                                
               kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
            enddo
         endif
         go to 15
      endif


c*****if the observed and computed RWs are close, do a final gf adjustment
c*****and finish with one more line recomputation
      if (ncurve .eq. 30) then
         write (nf1out,1001)
         write (nf2out,1001)
      endif
      gf1(ncurve) = gf1(ncurve-1)*ratio
      do i=1,ntau
         kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
      enddo
      call oneline (2)
      widout(lim1) = w(ncurve)
      wid1comp(lim1) = w(1)
      diff = dlog10(gf1(ncurve)/gf(lim1))
      abundout(lim1) = abundin + diff
      if (ncurve .ne. 1) then
         write (nf1out,1002) ncurve
      endif


      return


c*****format statements
1001  format ('OH NO! ANOTHER FAILED ITERATION!')
1002  format (' This fit required ',i2,' iterations including ',
     .        'a final small adjustment'/)


      end

      subroutine cdcalc_JS (number)
c******************************************************************
c     Calculates the line depth and accordingly, the quantity adepth
c     (analogous to the quantity, cd(i), in MOOG-NONscat).
c     The quantity 'adepth' is the depth of the spectral line at a specified 
c     wavelength. Essentially, the integral of this quantity over the wavelength of 
c     the spectral feature is the equivalent width. 

c******************************************************************
      implicit real*8 (a-h,o-z)
      real*8  Residual

      include 'Atmos.com'
      include 'Linex.com'
      include 'Source.com'
      
      if (number .eq. 1) then
         call sourcefunc_scat_cont
         return
      else  
         call sourcefunc_scat_line
      Residual = Flux_line/Flux_cont
      adepth   = 1.- Residual
      endif


      return
      end

 

      subroutine molquery
c******************************************************************************
c     This routine discovers whether a species being analyzed in EW 
c     predicting of force-fitting mode is involved in molecular equilibrium 
c     (=M.E.) calculations as well; the variables is set appropriately
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'

      molflag = 0
      iabatom = int(atom1(lim1obs)+0.0001)


c*****the species is an atom:
c*****search for it in the list of elements done in M.E.
      if (atom1(lim1line) .lt. 100.) then
         if (neq .eq. 0) then
            return
         else
            do n=1,neq
               if (iabatom .eq. iorder(n)) molflag = 1
               return
            enddo
         endif


c*****the species is a molecule:
c*****halt if M.E. wasn't done or didn't include this species
      else
         if (neq .eq. 0) then
            lscreen = lscreen + 2
            write (array,1001) iabatom
            call prinfo (lscreen)
            stop
         endif
         call sunder(atom1(lim1obs),ia,ib)
         iaa = ia
         ibb = ib
         do n=1,neq
            if (ia.eq.iorder(n) .or. ib.eq.iorder(n)) molflag = ia
         enddo
         if (molflag .eq. 0) then
            lscreen = lscreen + 2
            write (array,1002) iabatom
            call prinfo (lscreen)
            stop
         endif
         molflag = 1

c*****if molecule is a hydride, the non-H element will be varied
         if (ia.eq.1 .or. ib.eq.1) then
            if (ia .eq. 1) then
               iabatom = ib
            else
               iabatom = ia
            endif


c*****for other molecules, the user specifies which element will be varied
         else
            write (array,1003) iabatom
            nchars = 56
            call getnum (nchars,ikount+1,xnum,shortnum)
            iabatom = int(xnum+0.0001)
         
            if (iabatom.ne.ia .and. iabatom.ne.ib) then
               write (array,1003)
               stop
            endif
         endif
         return
      endif


c*****format statements
1001  format ('YOU FORGOT TO DO MOLECULAR EQUILIBRIUM FOR ',
     .        'SPECIES ', i3, '; I QUIT!')
1002  format ('YOUR MOLECULAR EQUILIBRIUM DOES NOT INCLUDE ',
     .        'THE ATOMS FOR SPECIES ', i3, '; I QUIT!')
1003  format ('LINES OF SPECIES ', i3, ' ARE NEXT: ',
     .        '   CHANGE ATOMIC NUMBER? ')


      end

      subroutine smooth (line,ncall)
c******************************************************************************
c     This subroutine prepares synthesis data for plotting by smoothing
c     the data in various ways.
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*4 shortnum
      character*5 abchars
      character*4 isochars


c*****initialize parameters
      write (abitle(1:400),1081)
      write (isoitle(1:240),1082)
      nsyn = 1
      if (ncall .eq. 1) then
         gaussflag = 'f'
         rotateflag = 'f'
         lorenflag = 'f'
         macroflag = 'f'
         if (choice .ne. 'l') addflux = 0.
      endif


c*****on entering, figure out what kind of smoothing is desired, unless
c     the default smoothing options have been set for first pass 
      if (line .gt. 0) then
2        write (array,1007)
         istat = ivwrite (line,3,array,67)
         write (array,1004)
         istat = ivwrite (line+1,3,array,50)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+2)
         smtype = chinfo(1:1)
         if (smtype.ne.'n' .and. smtype.ne.'g' .and.
     .       smtype.ne.'l' .and. smtype.ne.'v' .and.
     .       smtype.ne.'m' .and. smtype.ne.'c' .and.
     .       smtype.ne.'d' .and. smtype.ne.'r' .and.
     .       smtype.ne.'p') go to 2
      endif


c     if a user-specified variable Gaussian smoothing over the spectral range
c     is called for, option 'p', branch to a different routine
      if (smtype .eq. 'p') then
         call vargauss (line+1)
         return
      endif
 

c*****rewind the unsmoothed and smoothed spectrum output 
c     files, and get the synthesis range parameters from the 'dump' file
      rewind nf2out
      rewind nf3out
      do i=1,20
         read (nf2out,1002) array
         if     (array(1:7).eq.'element' .or.  
     .       array(1:7).eq.'Changin' .or.
     .       array(1:7).eq.'ALL abu' .or.
     .       array(1:7).eq.'Isotopi') then
            cycle
         elseif (array(1:7).eq.'MODEL: ') then
             moditle(1:73) = array(8:80)
            read (nf2out,*) start, sstop, step
            kount = int((sstop - start + (step/4.0) )/step) + 1
            exit
         endif
      enddo
      
c*****branch to the desired smoothing function
      write (smitle,1010) smtype
      ism = 11
      if     (smtype .eq. 'l') then
         lorenflag = 't'
      elseif (smtype .eq. 'g') then
         gaussflag = 't'
      elseif (smtype .eq. 'v') then
         rotateflag = 't'
      elseif (smtype .eq. 'c') then
         rotateflag = 't'
         gaussflag = 't'
      elseif (smtype .eq. 'm') then
         macroflag = 't'
      elseif (smtype .eq. 'd') then
         macroflag = 't'
         gaussflag = 't'
      elseif (smtype .eq. 'r') then
         macroflag = 't'
         rotateflag = 't'
         gaussflag = 't'
      endif


c*****compute a stellar rotational broadening function; this follows 
c     D. F. Gray, 1976, "The Obs. & Anal. of Stell. Phot", p394-9
      if (rotateflag .eq. 't') then
32       array = 'GIVE THE STELLAR vsini [0.0]: '
         nchars = 30
         if (line .gt. 0) then
            call getnum (nchars,line+2,vsini,shortnum)
            if (vsini .eq. -9999.) vsini = 0.
         endif
         if (vsini .lt. 0.0) go to 32
         write (smitle(ism+1:ism+13),1011) vsini
         ism = ism + 13
31       array = 'GIVE THE LIMB DARKENING COEFFICIENT [0.0]: '
         nchars = 43
         if (line .gt. 0) then
            call getnum (nchars,line+2,limbdark,shortnum)
            if (limbdark .eq. -9999.) limbdark = 0.
         endif
         if (limbdark .lt. 0.0) go to 31
         write (smitle(ism+1:ism+13),1012) limbdark
         ism = ism + 13
         dlamlim = (start+sstop)/2.*vsini/3.0e5
         if (step .ge. dlamlim) then
            rotateflag = 'f'
         else
            pi = 3.141527
            bottom = dlamlim*pi*(1.-limbdark/3.)
            c1 = 2.*(1.-limbdark)/bottom
            c2 = 0.5*limbdark*pi/bottom
            prot0 = c1 + c2
            powerrot = prot0
            jdelrot = idint(dlamlim/step)
            if (jdelrot .gt. 1000) then
               write (*,1026) 
               smtype = 'e'
               return
            elseif (jdelrot .gt. kount/4) then
               write (*,1028)
               smtype = 'e'
               return
            endif
            do i=1,jdelrot
               dlam = (i-1)*step
               term = 1. - (dlam/dlamlim)**2
               prot(i) = c1*dsqrt(term) + c2*term
               powerrot = powerrot + 2.0*prot(i)
            enddo
         endif
      endif

         
c*****compute a macroturbulent smoothing function (uses subroutine vmacro)
      if (macroflag .eq. 't') then
51       array = 'GIVE THE MACROTURBULENT VELOCITY [0.0]: '
         nchars = 39
         if (line .gt. 0) then
            call getnum (nchars,line+2,vmac,shortnum)
            if (vmac .eq. -9999.) vmac = 0.
         endif
         if (vmac .lt. 0.0) go to 51
         write (smitle(ism+1:ism+13),1013) vmac
         ism = ism + 13
         if (vmac .eq. 0.) then
            macroflag = 'f'
         else
            wavemac = (start+sstop)/2.*vmac/3.0e5
            powermac = 1.0
            do i=1,1000
               wavei = step*i/wavemac
               pmac(i) = vmacro(wavei)
               powermac = powermac + 2.0 *pmac(i)
               if (pmac(i) .lt. 0.002) then
                  jdelmac = i
                  exit
               endif 
            enddo
            if (jdelmac .gt. 1000) then
               write (*,1025) wavemac
               smtype = 'e'
               return
            elseif (jdelmac .gt. kount/4) then
               write (*,1022)
               smtype = 'e'
               return
            endif   
         endif
      endif


c*****compute a Gaussian smoothing function
      if (gaussflag .eq. 't') then
11       array = 'GIVE THE FWHM OF THE GAUSSIAN FUNCTION [0.0]: ' 
         nchars = 46
         if (line .gt. 0) then
            call getnum (nchars,line+2,fwhmgauss,shortnum)
            if (fwhmgauss .eq. -9999.) fwhmgauss = 0.
         endif
         if (fwhmgauss .lt. 0.0) go to 11
         write (smitle(ism+1:ism+18),1014) fwhmgauss
         ism = ism + 18
         if (fwhmgauss .eq. 0.) then
            gaussflag = 'f'
         else
            sigma = fwhmgauss/2.
            aa = 0.6932/sigma**2
            power = 1.0
            do i=1,1000
               p(i) = dexp(-aa*(step*i)**2 )
               power = power + 2*p(i)
               if (p(i) .lt. 0.02) then
                  jdel = i
                  exit
               endif
            enddo
            if (jdel .gt. 1000) then
               write (*,1029) sigma
               smtype = 'e'
               return   
            elseif (jdel .gt. kount/4) then
               write (*,1021)
               smtype = 'e'
               return
            endif
         endif
      endif


c*****compute a Lorenzian smoothing function
      if (lorenflag .eq. 't') then
21       array = 'GIVE THE FWHM OF THE LORENTZIAN FUNCTION [0.0]: '
         nchars = 48
         if (line .gt. 0) then
            call getnum (nchars,line+2,fwhmloren,shortnum)
            if (fwhmloren .eq. -9999.) fwhmloren = 0.
         endif
         if (fwhmloren .lt. 0.0) go to 21
         write (smitle(ism+1:ism+20),1015) fwhmloren
         ism = ism + 20
         if (fwhmloren .eq. 0.) then
            lorenflag = 'f'
         else
            sigma = fwhmloren/2.
            power = 1.0
            do i=1,1000
               p(i) = ((sigma**2)/((sigma**2)+((step*i)**2)))
               power = power + 2.0 *p(i)
               if (p(i) .lt. 0.02) then
                  jdel = i
                  exit
               endif
            enddo    
            if (jdel .gt. 1000) then
               write (*,1030) sigma
               smtype = 'e'
               return  
            elseif (jdel .gt. kount/4) then
               write (*,1031)
               smtype = 'e'
               return
            endif
         endif
      endif


c*****finally there is a big loop that will read in the raw synthetic spectra,
c*****beginning with grabbing the information that appears before the array
c*****spectrum depth array,  Note that after the depth array is input, the
c*****code will flip to a flux scale
      rewind nf2out
      do nsyn=1,100


c*****here is the reading/grabbing of stuff preceding the depth array:
         naboff = 80*(nsyn-1)
         nabunds = 0
         nisos = 0
         do i=1,20
            read (nf2out,1002,end=2000) array
            if     (array(1:7).eq.'ALL abu') then
               cycle
            elseif (array(1:7).eq.'Changin') then
               abitle (naboff+1:naboff+23) = '[M/H] FOR ALL ELEMENTS:'
               abitle (naboff+24:naboff+29) = array(32:37)
               cycle
            elseif (array(1:7).eq.'element') then
               nabunds = nabunds + 1
               if (control .eq. 'binary ') then
                  if (nabunds .le. 5) then
                     ioff = naboff + 16*(nabunds-1)
                     abitle(ioff+1:ioff+2) = array(9:10)
                     abitle(ioff+3:ioff+14) = array(26:37)
                     abitle(ioff+15:ioff+16) = '  '
                  endif
               else
                  if (nabunds .le. 8) then
                     ioff = naboff + 9*(nabunds-1)
                     abitle(ioff+1:ioff+2) = array(9:10)
                     read (array(26:32),*) abnum
                     if     (abnum .gt. 0) then
                        write (abchars,1061) abnum
                     elseif (abnum .le. -10.) then
                        write (abchars,1062) abnum
                     else
                        write (abchars,1063) abnum
                     endif
                     abitle(ioff+3:ioff+7) = abchars
                     abitle(ioff+8:ioff+9) = '  '
                  endif
               endif
               cycle
            elseif (array(1:7).eq.'Isotopi') then
               nisos = nisos + 1
               if (nisos .le. 6) then
                  read (array(37:46),1050) ratio
                  if     (ratio .ge. 1000.) then 
                     write (isochars,1054) int(ratio)
                  elseif (ratio .ge.  100.) then
                     write (isochars,1051) ratio
                  elseif (ratio .ge.   10.) then 
                     write (isochars,1052) ratio
                  else
                     write (isochars,1053) ratio
                  endif
                  if (nsyn .eq. 1) then
                     ioff = 40*(nisos-1) + 5*(nsyn-1)
                     isoitle(ioff+1:ioff+10) = array(23:32)
                     isoitle(ioff+11:ioff+12) = ': '
                     isoitle(ioff+13:ioff+16) = isochars(1:4)
                     isoitle(ioff+17:ioff+17) = '/'
                  else
                     ioff = 12 + 40*(nisos-1) + 5*(nsyn-1)
                     isoitle(ioff+1:ioff+4) = isochars(1:4)
                     isoitle(ioff+5:ioff+5) = '/'
                  endif
               endif
            elseif (array(1:7).eq.'MODEL: ') then
               read (nf2out,1002) array
               exit
            endif
         enddo


c*****here is the actual reading of the depth array
         read (nf2out,1003,end=2000) (y(i),i=1,kount)
         do i=1,kount
            y(i) = 1.0 - y(i)
         enddo


c*****here a veiling addition can be added in
         if (addflux .gt. 0.0) then
             do i=1,kount
                 y(i) = (y(i) + addflux)/(1.0+addflux)
             enddo
         endif


c*****apply the rotational broadening if desired
         if (rotateflag .eq. 't') then
            min = jdelrot + 1
            max = kount - jdelrot
            do i=1,jdelrot
               z(i) = 1.
               z(kount-i+1) = 1.
            enddo
            do i=min,max
               z(i) = prot0*y(i)
               do j=1,jdelrot
                  z(i) = z(i) + prot(j)*(y(i-j) + y(i+j))
               enddo
               z(i) = z(i)/powerrot
            enddo
            do i=1,kount
               y(i) = z(i)
            enddo
         endif


c*****apply the macroturbulent broadening if desired
         if (macroflag .eq. 't') then
            min = jdelmac + 1
            max = kount - jdelmac
            do i=1,jdelmac
               z(i) = 1.
               z(kount-i+1) = 1.
            enddo
            do i=min,max
               z(i) = y(i)
               do j=1,jdelmac
                  z(i) = z(i) + pmac(j)*(y(i-j) + y(i+j))
               enddo
               z(i) = z(i)/powermac
            enddo
            do i=1,kount
               y(i) = z(i)
            enddo
         endif


c*****apply the Gaussian or Lorenzian smoothing if desired (this
c     is an either/or situation; only one of these can apply.
         if (gaussflag .eq. 't' .or. lorenflag .eq. 't') then
            min = jdel + 1
            max = kount - jdel
            do i=1,jdel
               z(i) = 1.
               z(kount-i+1) = 1.
            enddo
            do i=min,max
               z(i) = y(i)
               do j=1,jdel
                  z(i) = z(i) + p(j)*(y(i-j) + y(i+j))
               enddo
               z(i) = z(i)/power
            enddo
            do i=1,kount
               y(i) = z(i)
            enddo
         endif


c*****move the smoothed spectrum (or unsmoothed, if nothing has
c     been done to the y-array) into the appropriate array
         do i = 1,kount
            chunk(i,nsyn) = y(i)
         enddo
   

c*****compute the wavelength array; must be done for each synthetic
c     spectrum because of the way the equivalences were set up
         if     (iunits .eq. 1) then
            do i=1,kount
               xsyn(i) = 1.d-4*(start + (i-1)*step)
            enddo
         else
            do i=1,kount
               xsyn(i) = start + (i-1)*step
            enddo
         endif


c*****dump the smoothed spectrum in a MONGO-style set of 
c     (wavelength,flux) point pairs
         write (nf3out,1005) kount,start,sstop,step
         if (xsyn(1) .le. 100.0) then
            write (nf3out,1009) (xsyn(i),chunk(i,nsyn),i=1,kount)
         else 
            write (nf3out,1008) (xsyn(i),chunk(i,nsyn),i=1,kount)
         endif
      enddo


c*****exit the routine normally
2000  nsyn = nsyn - 1
      return


c*****a problem has developed in user-specified parameter (like a Gaussian
c     FWHM being too big); print out a warning and let user decide what
c     to do next


c*****format statements
1002  format (a80)
1003  format (10f7.4)
1004  format ('           c=v+g, d=m+g, r=m+v+g, p=VARIABLE GAUSS')
1005  format ('the number of points per synthesis = ',i5/
     .        'start = ',f10.3,5x,'stop = ',f10.3,5x,'step = ',f10.3)
1007  format ('SMOOTHING: n=NONE, g=GAUSS, l=LORENZ, ',
     .        'v=ROTATION, m=MACROTURBULENCE')
1008  format (f10.3,'  ',f10.5)
1009  format (f10.6,'  ',f10.5)
1010  format ('smoothing=',a1,69x)
1011  format ('  Vsini=',f5.1)
1012  format ('  L.D.C.=',f4.2)
1013  format ('  Vmacro=',f4.1)
1014  format ('  FWHMgauss=',f6.3)
1015  format ('  FWHMlorentz=',f6.3)
1021  format ('ERROR: GAUSSIAN PROFILE COVERS WHOLE ',
     .        'SPECTRUM!'/
     .        '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .        'STEP SIZE?')
1022  format ('ERROR: MACROTURBULENT PROFILE COVERS WHOLE ',
     .        'SPECTRUM!'/
     .        '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .        'STEP SIZE?')
1025  format ('ERROR: MACROTURBULENT PROFILE TOO BIG! ',
     .        '(WAVELENGTH WIDTH=',f6.2,')'/
     .        '       INCREASE SPECTRUM STEP SIZE?')
1026  format ('ERROR: ROTATIONAL PROFILE TOO BIG!'/  
     .        '       INCREASE SPECTRUM STEP SIZE?')
1028  format ('ERROR: ROTATIONAL PROFILE COVERS WHOLE ',
     .        'SPECTRUM!'/
     .        '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .        'STEP SIZE?')
1029  format ('ERROR: GAUSSIAN PROFILE TOO BIG! ',
     .        '(HALF WIDTH=',f6.2,')'/
     .        '       INCREASE SPECTRUM STEP SIZE?')
1030  format ('ERROR: LORENZIAN PROFILE TOO BIG! ',
     .        '(HALF WIDTH=',f6.2,')'/
     .        '       INCREASE SPECTRUM STEP SIZE?')
1031  format ('ERROR: LORENZIAN PROFILE COVERS WHOLE ',
     .        'SPECTRUM!'/
     .        '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .        'STEP SIZE?')
1050  format (f10.3)
1051  format (f4.0)
1052  format (f4.1)
1053  format (f4.2)
1054  format (i4)
1061  format ('+', f4.2)
1062  format (f5.1)
1063  format (f5.2)
1081  format (400(' '))
1082  format (240(' '))

      end

      subroutine drawcurs
c******************************************************************************
c     This subroutine draws an arrow and writes the user x- and y-positions
c     of the cursor upon a click
c******************************************************************************

      include 'Pstuff.com'
      integer ichr


c      call sm_graphics
c      if     (whichwin .eq. '1of1') then
c         call sm_window (1,1,1,1,1,1)
c      elseif (whichwin .eq. '2of2') then
c         call sm_defvar ('y_gutter','0.0')
c         call sm_window (1,2,1,1,1,1)
c      endif
c      call sm_curs (xplotpos,yplotpos,ichr)
c
c
c      call sm_relocate (xplotpos,yplotpos-0.10*(yhi-ylo))
c      call sm_draw (xplotpos,yplotpos)
c      call sm_draw (xplotpos-0.01*(xhi-xlo),yplotpos-0.03*(yhi-ylo))
c      call sm_relocate (xplotpos,yplotpos)
c      call sm_draw (xplotpos+0.01*(xhi-xlo),yplotpos-0.03*(yhi-ylo))
c      call writenumber (xplotpos)
c      call sm_expand (0.6)
c      call sm_relocate (xplotpos,yplotpos-0.11*(yhi-ylo))
c      call sm_putlabel (5,array)
c      call writenumber (yplotpos)
c      if     (whichwin(4:4) .eq. '1') then
c         call sm_relocate (xplotpos,yplotpos-0.15*(yhi-ylo))
c      elseif (whichwin(4:4) .eq. '2') then
c         call sm_relocate (xplotpos,yplotpos-0.18*(yhi-ylo))
c      elseif (whichwin(4:4) .eq. '3') then
c         call sm_relocate (xplotpos,yplotpos-0.21*(yhi-ylo))
c      endif
c      call sm_putlabel (5,array)
c
c
c      call sm_gflush
c      call sm_alpha


      
      return
      end

      subroutine makeplot (lscreen)
c******************************************************************************
c     This subroutine does the plot-package-specific commands to begin
c     a plot, then calls the specific plot drawing routine, then ends the
c     plot.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'
      integer sm_device, lscreen, nchars


cc  open the plot device: screen terminal
c      if (plotroutine(1:4) .eq. 'term') then
c         if (sm_device(smterm) .lt. 0) then
c            write (array,1001) smterm
c            istat = ivwrite(lscreen+1,1,array,79)
c            write (nf1out,1007) array(1:79)
c            stop
c         endif
c      endif
c
c
cc  open the plot device: hardcopy sent to printer
c      if (plotroutine(1:4) .eq. 'hard') then
c         if     (plotroutine(6:9) .eq. 'land') then
c            if     (sm_device('postland') .lt. 0) then
c               write (array,1002)
c               istat = ivwrite(lscreen+1,1,array,34)
c               write (nf1out,1007) array(1:34)
c               stop
c            endif
c         elseif (plotroutine(6:9) .eq. 'port') then
c            if (sm_device('postport') .lt. 0) then
c               write (array,1009)
c               istat = ivwrite(lscreen+1,1,array,34)
c               write (nf1out,1007) array(1:34)
c               write (nf1out,1009)
c               stop
c            endif
c         endif
c      endif
c
c
cc  open the plot device: postscript file
c      if (plotroutine(1:4) .eq. 'file') then
c         if (f5out .eq. 'optional_output_file') then
c            array = 'Give the file name for the POSTSRIPT plot image: '
c            nchars = 49
c            call getasci (nchars,maxline)
c            f5out = chinfo(1:nchars)
c         else
c            nchars = 80
c            call getcount (nchars,f5out)
c         endif
c         if     (plotroutine(6:9) .eq. 'land') then
c            if (nchars .lt. 10) then
c               write (errmess,1003) nchars
c            else
c               write (errmess,1004) nchars
c            endif
c         elseif (plotroutine(6:9) .eq. 'port') then
c            if (nchars .lt. 10) then
c               write (errmess,1005) nchars
c            else
c               write (errmess,1006) nchars
c            endif
c         endif
c         write (array,errmess) f5out(1:nchars)
c         if (sm_device(array(1:nchars+13)) .lt. 0) then
c            write (nf1out,1007) array(1:nchars+9)
c            istat = ivwrite(lscreen+1,1,array,nchars+9)
c            stop
c         endif
c      endif
c
c
cc  issue standard beginning commands
c      call sm_graphics
c      call sm_erase
c
c
cc  call the routine that makes the desired plot
c      if     (plotroutine(11:14) .eq. 'cog ') then
c         call cogplot
c      elseif (plotroutine(11:14) .eq. 'abun') then
c         call abunplot
c      elseif (plotroutine(11:14) .eq. 'spec') then
c         call specplot
c      elseif (plotroutine(11:14) .eq. 'bin ') then
c         call binplot
c      elseif (plotroutine(11:14) .eq. 'flux') then
c         call fluxplot
c      endif
c
c
cc  issue standard ending commands; exit normally
c      if (plotroutine(1:4) .eq. 'file') then
c         f5out = 'optional_output_file'
c      endif
c      call sm_gflush
c      if (plotroutine(1:4).eq.'hard' .or. 
c     .    plotroutine(1:4).eq.'file') call sm_hardcopy
c      call sm_alpha
      return


c*****format statements
1001  format ('DEVICE OPENING ERROR FOR:',a54)
1002  format ('DEVICE OPENING ERROR FOR: postland')
1009  format ('DEVICE OPENING ERROR FOR: postport')
1007  format (a80)
1003  format ('(13hpostlandfile ,a',i1,'$)')
1004  format ('(13hpostlandfile ,a',i2,'$)')
1005  format ('(13hpostportfile ,a',i1,'$)')
1006  format ('(13hpostportfile ,a',i2,'$)')


      end

      subroutine ewfind
c******************************************************************************
c     This routine predicts equivalent widths for individual atomic lines
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      include 'Source.com'
      real*8 taunu0(100)
      character*4 ion(3)
      data ion/' I  ', ' II ', ' III'/


c*****read the parameter file
      call params


c*****open the files for standard output and summary curves-of-growth
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY PREDICTED EW OUTPUT'
      nchars = 27
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open and read the line list file; get ready for the line calculations
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      isynth = 1
      call inlines (1)
      call eqlib
      call nearly (1)

 
c*****set some parameters and write header stuff to output
      ewsynthopt = +1
      mode = 1
      call linlimit
      lim1obs = lim1line
      lim2obs = lim2line
      istat = ivcleof (4,1)
      write (nf2out,1002) linitle,moditle


c*****run single line computations once to predict the EW for each line
      do lim1=lim1line,lim2line
         call molquery
         write (array,1001)
         lscreen = lscreen + 2
c        call prinfo (lscreen)
         write (nf2out,1001)
         ncurve = lim1
         lim2 = lim1
         gf1(ncurve) = gf(lim1)
         call oneline (1)
         widout(lim1) = w(ncurve)
         iatom = atom1(lim1)


         if (iatom .lt. 100) then
            xab = dlog10(xabund(iatom)) + 12.
         else
            xab = dlog10(xabund(iabtom)) + 12.
         endif
         ich = idint(charge(lim1) + 0.1)
         if (iatom .lt. 100) then
            write (array,1003) wave1(lim1), e(lim1,1), 
     .                         dlog10(gf(lim1)), names(iatom), 
     .                         ion(ich), xab, 1000.*widout(lim1)
            lscreen = lscreen + 2
c           call prinfo (lscreen)
            write (nf2out,1003) wave1(lim1), e(lim1,1), 
     .                          dlog10(gf(lim1)), names(iatom), 
     .                          ion(ich) ,xab, 1000.*widout(lim1)
         else
            write (array,1004) wave1(lim1), e(lim1,1), 
     .                         dlog10(gf(lim1)), names(iaa), 
     .                         names(ibb), xab, 1000.*widout(lim1)
            lscreen = lscreen + 2
c           call prinfo (lscreen)
            write (nf2out,1004) wave1(lim1), e(lim1,1), 
     .                          dlog10(gf(lim1)), names(iaa), 
     .                          names(ibb), xab, 1000.*widout(lim1)
         endif


c*****(re)compute the line optical depth at line center and the C_d curve
         do i=1,ntau
            kapnu(i) = kapnu0(lim1,i)
c*****Computed in subroutine Nearly
            dummy1(i) = tauref(i)*kapnu(i)/(0.4343*kapref(i))
         enddo
         first = tauref(1)*kapnu(1)/kapref(1)
         dummy2(1) = rinteg(xref,dummy1,taunu0,ntau,0.)
         taunu0(1) = first
         do i=2,ntau
            taunu0(i) = taunu0(i-1) + taunu0(i)
         enddo
         do i=1,ntau
            taunu(i) = taunu0(i)
         enddo
         if (scatopt .eq. 0) then
            call cdcalc (2)
         else
            call cdcalc_JS (2)
            do i=1,ntau
               cd(i) = adepth
            enddo
         endif
         if (linprintopt .ge. 2) then
            write (nf2out,1010) 
            write (nf2out,1011) (i, rhox(i), xref(i), int(t(i)), 
     .                          pgas(i), rho(i), kaplam(i), 
     .                          taulam(i), taunu0(i), cd(i), i=1,ntau)
         endif


c*****compute layer where continuum optical depth > 1
         do i=1,ntau
            if (taulam(i) .ge. 1.) then
               write (nf2out,1013) tauref(i), i
               go to 10
            endif
         enddo


c     compute layer where line center optical depth > 1
10          if (taunu0(ntau) .lt. 1.) then
               write (nf2out,1016)
               go to 20
            endif
            do i=1,ntau
            if (taunu0(i) .ge. 1.) then
               write (nf2out,1014) tauref(i), i
               go to 20
            endif
         enddo


c     compute layer where line center plus continuum optical depth > 1
20       do i=1,ntau
            if (taunu0(i)+taulam(i) .ge. 1.) then
               write (nf2out,1015) tauref(i), i
               go to 30
            endif
         enddo


*****compute mean line-center formation level (weight: contribution function)
30       do i=1,ntau
            dummy1(i) = xref(i)*dabs(cd(i))
         enddo
         xrefcdinteg = rinteg(xref,dummy1,dummy2,ntau,0.)
         do i=1,ntau
            dummy1(i) = dabs(cd(i))
         enddo
         cdinteg = rinteg(xref,dummy1,dummy2,ntau,0.)
         xrefmean = xrefcdinteg/cdinteg
         do i=1,ntau
            if (xrefmean .le. xref(i)) then
               write (nf2out,1017) 10**(xrefmean), i
               go to 40
            endif
         enddo
40       continue
      enddo


c*****end the abundance computations
      call finish (0)
      return


c*****format statements
1001  format ('wavelength        EP     logGF     ident',
     .        '     Abund    EWcalc')
1002  format (a80)
1003  format (f10.2,f10.2,f10.3,'     ',a2,a3,f10.2,f10.1)
1004  format (f10.2, f10.2, f10.3, 6x, a2, a2, f10.2, f10.1)
1010     format (' i', 5x, 'rhox', 2x, 'xref', 5x, 'T', 5x, 'Pgas', 
     .           6x, 'rho', 3x, 'kaplam', 3x, 'taulam',
     .           3x, 'taunu0', 8x, 'Cd')
1011  format (i2, 1pd9.2, 0pf6.2, i6, 1p5d9.2, d10.2)
1013           format (5x, 'tau(ref) =', 1pe10.2,
     .                 ' (level=',i2, ') for tau(cont) ~ 1')
1014           format (5x, 'tau(ref) =', 1pe10.2,
     .                 ' (level=',i2, ') for tau(line) ~ 1')
1015           format (5x, 'tau(ref) =', 1pe10.2,
     .                 ' (level=',i2, ') for tau(cont+line) ~ 1')
1016           format (7x,'  NOTE: line center tau(line) < 1',
     .                 '  at deepest atmosphere layer')
1017           format (5x, 'C_d weighted mean formation tau(ref) =',
     .                 1pe10.2, ' (level=',i2, ')')

      end

      subroutine getasci (num,line)
c******************************************************************************
c     this routine asks for information, by printing out the
c     characters contained in 'array', and returns what the
c     user types out in array 'chinfo'.  Variable 'num' on input
c     is the number of characters in 'message', and on output is
c     the number of characters in 'chinfo'
c******************************************************************************

      include 'Pstuff.com'

      write (chinfo,1005)
1005  format (80(' '))

      istat = ivmove(line-1,1)
      istat = ivcleol()
      istat = ivmove(line-1,1)
      if (num .lt. 10) then
         write (errmess,1001) num
1001     format ('(a',i1,'$)')
      else
         write (errmess,1002) num
1002     format ('(a',i2,'$)')
      endif
      write (*,errmess) array
      num = 80 - num
      if (num .lt. 10) then
         write (errmess,1003) num
1003     format ('(a',i1,')')
      else
         write (errmess,1004) num
1004     format ('(a',i2,')')
      endif
      read (*,errmess) chinfo
      call getcount (num,chinfo)
       return

      end

      subroutine sourcefunc_scat_line
c******************************************************************
c     Calculates the *LINE+CONT* source function which incorporates both a
c     scattering and an absorption component.  The relevant quantities are S_line (source function),
c     J_line (the mean intensity), and Flux_line (the total flux).  Note that these
c     quantities have a dependence on frequency that will be incorporated in future MOOG versions.
c     Employs the short characteristics methodology.
c******************************************************************
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Source.com'
      data jentry /0/

c***  Local Arrays/Variables
      real*8  ddm(100), alo(100), ood(100), ddmm(100), dtau1MI(100)
      real*8  Thomson_line(100), Scat_opacity(100), Therm_opacity(100)
      real*8  eta(100), etat(100)
      real*8  dtau(100), WOP(100), W1(100), W0(100)
      real*8  J_line_OLD(100), J_line_moog(100), S_line_MOOG(100)
      real*8  CF_U_tau(100), CF_U_tauref(100), CF_U_tauref_FIN(100)
      real*8  Factor_CF(100), tau_CF(100)
      real*8  kap_ratio_CF(100), exptau_CF(100), tau_ratio(100)
      integer IT

c***  Frequency loop: Definitions (real*8  pisqi, xfr(20), phi(20), wfr(20))
c      pisqi = 0.5641895835
c      xmax  = 5.
c      nfr   = 2.
c      if(xmax.le.0. .or. nfr.le.1) then
c         nfr    = 1.
c         phi(1) = 1.
c         wfr(1) = 1.
c         return
c      endif
c      dx  = xmax / dble(nfr-1)
c      sum = 0
c***  Freqency loop: Absorption profile assumed to be a simple Doppler profile
c      do ifr=1, nfr
c         x       = (ifr-1.)*dx
c         xfr(ifr)= x
c         phi(ifr)= exp(-x*x)*pisqi
c         wfr(ifr)= dx
c         if(ifr.eq.1.or.ifr.eq.nfr) then 
c            wfr(ifr)= dx * 0.5
c         endif
c         sum = sum + phi(ifr)*wfr(ifr)
c      enddo
c***  Frequency loop: Renormalization of frequency quadrature weights
c      do ifr=1, nfr
c         wfr(ifr) = wfr(ifr)/sum
c      enddo

c*** DETERMINE: rhox for MODELS that do not contain these values.  An additional constant might be necessary as kappa does vary.
      do i=1, ntau
         if (modtype .eq. 'KURTYPE   ' .or.
     >       modtype .eq. 'KURUCZ    ' .or.
     >       modtype .eq. 'WEBMARCS  ') cycle
         rhox(i) = tauref(i)/(kapref(i)/rho(i))
      enddo   

c*** INTEGRATION IN MU: Call the AngWeight.f subroutine (Gaussian Quadrature Summation).
c    During initial pass, calculate the Gaussian integration points and weights.
c    AngWeight.f operates ONLY with odd numbers of rays (mmu = 1, 3, 5,...).  Should correct this.
c    Note that with increasing ray number (>= 5), the mu value more closely approaches 1.
c    Called initially by Sourcefunc_scat_cont.f.  Duplicate call and probably should correct this. 
      if (jentry .eq. 0) then
         mmu = 5
         aaa = 0.
         bbb = 1.
         call angweight (mmu,aaa,bbb,wtmu,mu)
               xxx = 0
               do i=1,mmu
                   xxx = xxx + wtmu(i)
c                   write (0,'(A,1X,I2,1x,2p7e10.2)')
c     >             'results: i wtmu mu',i,wtmu(i),mu(i)
               enddo
         jentry = 1     
      endif

c*** SET-UP: delta_tau variable (name: dtau1).
      do i=1, ntau
        ood(i)     = (kaplam(i) + kapnu(i)) / rho(i)
        if (i .eq. 1)  cycle
        ddm(i)     = 0.5 * abs((rhox(i) - rhox(i-1)))
        dtau1(i)   = ddm(i) * (ood(i-1) + ood(i))
        if (i .eq. ntau) cycle
c        ddmm(i)    = 0.25 * (rhox(i+1) - rhox(i-1))
c        dtau1MI(i) = 1. / (ddmm(i) * (ood(i-1) + ood(i+1)))
c       write (0,'(A,1X, I2, F12.5, 1X, 1p7e10.2)')
c     >       'LINE: tau ood dtau', i, ood(i), dtau1(i)
      enddo

c*** SET-UP: Scat_opacity, Therm_opacity, and Thomson terms.  
c    Note, the S_line determination includes BOTH continuum- and line-associated quantities.
c    As is standard, Therm_opacity(i) = kaplam(i) - Scat_opacity(i).
      do i=1, ntau
         Scat_opacity(i)  = kaplamsca(i)
         Therm_opacity(i) = kaplamabs(i) + kapnu(i)
         Thomson_line(i)  = Scat_opacity(i)/(kaplam(i) + kapnu(i))
      enddo

c*** ACCELERATION OF CONVERGENCE: To accelerate the convergence of the solution of the RTE, it is necessary to employ the technique of 
c    accelerated lambda iteration (ALI).  The steps below set-up the lambda operator.  
c    Convergence Requirements (original values: Converg_iter = 1.e-5 and Max_iter = 25):
      Converg_iter = 2.E-3
      Max_iter     = 65
c     Gamma controls the amount of acceleration.
c     Gamma = 0 : No Acceleration
c           = 1 : Full Acceleration
c           > 1 : Acceleration with damping 
      gamma = 1.
      if (gamma .eq. 0.) then
         do i=1, ntau
           alo(i) = 1.
         enddo
      else
        do i=1, ntau
          if (i .eq. 1) then
            dtau_alo = dtau1(2)
          else if (i .eq. ntau) then
            dtau_alo = 0.5 * dtau1(ntau)                                         | APPLY necessary additonal damping for the inner boundary
          else
            dtau_alo = 0.5 * (dtau1(i) + dtau1(i+1))                             | COMMENT: sum (/integral) of 1/mu * dmu = Sum of mu * dmu = 0.5
          endif
          dtau_alo     = dtau_alo * Thomson_line(i) / (2. * gamma)               | EMPLOY the damping factor of 2. * gamma (alternate: dtau_alo = dtau_alo * 1. /)
          exp_dtau_alo = exp(-dtau_alo)                                          | CREATE lambda operator with above-listed THOMSON factor
          if (exp_dtau_alo .ne. 1.) then
            alo(i) = dtau_alo / (1. - exp(-dtau_alo))
          else
            alo(i) = 1.
          endif
        enddo
      endif

c***  SET-UP: Fundamental Quantities (e.g., emissivity from Planck Function)
      Const1       = 1.43878858E08
      Const2       = 3.972610376E08
      H_line       = Const1/wave
      H_line_core  = H_line/t(ntau)
      B_core       = Const2/((exp(H_line_core)-1.)*wave*wave*wave)
      H_line_core1 = H_line/t(ntau-1)
      B_core1      = Const2/((exp(H_line_core1)-1.)*wave*wave*wave)
      DB_core      = B_core-B_core1


c***  SET-UP: Critical parameters such as the Planck Function (B), the Initial Mean Intensity (J_line_OLD), etc.
      do i=1, ntau
        H_line_t        = H_line / t(i)
        B_planck(i)     = Const2/((exp(H_line_t)-1.)*wave*wave*wave)
        J_line_OLD(i)   = B_planck(i)
        eta(i)          = B_planck(i) * Therm_opacity(i)
        etat(i)         = Scat_opacity(i) * J_line_OLD(i)
      enddo
 
c     ---------------------------------
c***  START of the main ITERATION loop (iteration preformed to achieve convergence in the solution of the RTE)
c     ---------------------------------
      IT   = 0
      do
        IT = IT + 1
c***    PROPOSED START of the FREQUENCY loop (ifr points)
        do i=1,ntau
           J_line_OLD(i)     = J_line(i)
           J_line(i)         = 0.
           S_line(i)         = (eta(i)+etat(i))/(kaplam(i)+kapnu(i))
        enddo
	Flux_line = 0.
c     --------------------------
c***  START of the ANGLE loop (integration in both tau and mu) 
c     --------------------------
        do j=1, mmu
           XI = 0.                                                         | NO INCIDENT RADIATION
           do i=2, ntau                                                    | BEGIN Depth Loop: Integration Inwards
              dtau(i)   = dtau1(i) / mu(j)
              exptau    = dexp(-dtau(i))
              WOP(i)    = (exptau - 1.) / dtau(i)
              W0(i)     = 1. + WOP(i)
              W1(i)     = -exptau - WOP(i)
              XI        = XI*exptau+W0(i)*S_line(i)+W1(i)*S_line(i-1)
              J_line(i) = J_line(i) + 0.5 * wtmu(j) * XI
           enddo                                                            | End Depth Loop  
           XI = 0.5*wtmu(j)*(B_core+(DB_core*mu(j)/dtau1(ntau)))            | PREPARE Inner Boundary: multiplied by 2/dtau
           J_line(ntau) = J_line(ntau) + XI                                 | SET Inner Boundary Condition
           do i=ntau-1, 1, -1                                               | BEGIN Depth Loop: Integration Outwards
                 dtau(i)   = dtau1(i+1) / mu(j)
                 exptau    = dexp(-dtau(i))
                 WOP(i)    = (exptau - 1.) / dtau(i)
                 W0(i)     = 1. + WOP(i)
                 W1(i)     = -exptau - WOP(i)
                 XI        = XI*exptau+W0(i)*S_line(i)+W1(i)*S_line(i+1)
                 J_line(i) = J_line(i) + 0.5 * wtmu(j) * XI
           enddo                                                             | End Depth Loop 
           Flux_line = Flux_line+XI*0.5*wtmu(j)*mu(j)                        | CALCULATE Emergent Flux (CRITICAL OUTPUT QUANTITY!)
c     -----------------
c***  END of ANGLE loop
c     -----------------
        enddo
c     PROPOSED Frequency loop code: Flux_line_freq(ifr) = Flux_line; do i=1, ntau; J_line_freq(i) = J_line_freq(i) + J_line(i)*wfr(ifr)*phi(ifr); enddo
c     PROPOSED END of Frequency Loop

c***  ACCELERATION OF CONVERGENCE: Calculate new etat and prepare to exit iteration loop (note ALI applied)
        q_max = 0.
        i_max = 0.
        do i=1, ntau
          etat_new = Scat_opacity(i) * J_line(i)                              | SET-UP the etat_new quantity
          DE       = etat_new - etat(i)                                       | DETERMINE new value of delta(etat)
          DE       = DE * alo(i)                                              | APPLY acceleration to delta(etat)
          etat_new = etat(i) + DE                                             | CALCULATE the "accerlerated" etat_new quantity 
          QNA      = (etat_new - etat(i)) / etat_new                          | COMPUTE convergence_quantity_1 
          Q        = ABS(etat_new - etat(i)) / etat_new                       | COMPUTE convergence_quantity_2
          if (Q .gt. q_max) then
            q_max   = Q
            q_maxNA = QNA
            i_max   = i
          endif
          etat(i) = etat_new                                                   | SET-UP and pass the iterated etat quantity to next loop
        enddo 
        if (q_max .le. Converg_iter .or. Max_iter .eq. 1) exit                 | DETERMINE if convergence requirements met and EXIT routine (IMPT. STEP!)
        if (IT .ge. Max_iter) then                                             | NOTIFY user if the maximum number of iterations exceeded
          write (0,'(A,F12.5,1X,1p7e10.2,1X,I3,1X,I3)')
     >      'Maximum number of iterations exceeded : wave, q_max= ',
     >      wave, q_max, i_max, ntau
          exit                                                                 | EXIT routine if maximum number of iterations exceeded
        endif

c     ---------------------
c***  END of ITERATION loop
c     ---------------------
      enddo

c     Attempt to determine the contribution function to the line with the methodology of Albrow & Cottrell (1996).
c     Note that the line soure function, S_line, does include some continuum quantity values (e.g., kaplam).
      Factor_CF(i)       = 0.
      CF_U_tauref_FIN(i) = 0.

      do i =1,ntau
         tau_CF(i)       = (kaplam(i) + kapnu(i)) * rhox(i)
         kap_ratio_CF(i) = kaplam(i)/(kaplam(i)+kapnu(i))
      enddo
c      do j=1,mmu
         do i =1,ntau
c            tau_ratio(i)   = tau_CF(i)/mu(j)
c            exptau_CF(i)   = dexp(-tau_ratio(i))
c            Factor_CF(i)   = exptau_CF(i)*wtmu(j)*mu(j)
            CF_U_tau(i)    = kap_ratio_CF(i) 
     >                       * (J_cont(i)-S_line(i))
c     >                       * 
            CF_U_tauref(i) = (tauref(i)*kapnu(i))/(0.4343*kapref(i))
     >                       * (J_cont(i)-S_line(i))
c     >                       * Factor_CF(i)          
c            CF_U_tauref_FIN(i) = CF_U_tauref_FIN(i)+CF_U_tauref(i)
         enddo
c       enddo

c       do i=1,ntau                  
c          write (0,'(A,1X,I2,1x,F12.3,1x,2(1p7e10.3))')
c     >             'i wave C_U_tau C_U_tauref:',
c     >             i,wave,CF_U_tau(i),CF_U_tauref(i) 
c        enddo
c        pause

c***  CONVERT variables to MOOG/Edmonds format/units (if desired).
      do i=1,ntau
         S_line_moog(i) = 2.9977518E26*(1/(wave**2))*S_line(i)
         J_line_moog(i) = 2.9977518E26*(1/(wave**2))*J_line(i)
      enddo
      Flux_line_moog = 2.9977518E26*(1/(wave**2))*Flux_cont


c     ---------------------
c***  END of ROUTINE
c     ---------------------
      return
      end

      program moogsynth
c******************************************************************************
c     This is the main driver for the non-interactive version of MOOG.  
c     It reads the parameter file and sends MOOG to various controlling 
c     subroutines.  In this version of MOOG the parameter file must
c     be named "batch.par" (because the code cannot stop to ask the
c     user to name the parameter file)
c******************************************************************************

      include 'Atmos.com'
      include 'Pstuff.com'
      character temp*100

c$$$$$$$$$$$$$$$$$$$$$$$$ USER SETUP AREA $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c     in compiling MOOG, here the various machine-specific things are
c     declared.  First, define the directory where MOOG lives, in order to
c     be able to pull in auxiliary data files; executing 'make' will
c     generate a reminder of this
      write (moogpath,1001)
      moogpath = 
     .  '$SRCDIR'

c*****What kind of machine are you using?  Possible ones are:
c     "mac" = Intel-based Apple Mac
c     "pcl" = a PC or desktop running some standard linux like Redhat
c     "uni" = a machine running Unix, specifically Sun Solaris
      machine = "$MACHINE"


c*****for x11 terminal types, define the parameters of plotting windows;
c     set up an x11 screen geometry and placement that is good for spectrum
c     syntheses (long, but not tall); the user should play with the format
c     statements for particular machines.
      write (smt1,1018)
c     now do the same for line abundance trend plots (short but tall).
      write (smt2,1017)
c$$$$$$$$$$$$$$$$$$$$$$$ END OF USER SETUP $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


c*****declare this to be the non-interactive version; variable "silent"
c     will be queried on all occasions that might call for user input;
c     DON'T CHANGE THIS VARIABLE; 
c     if silent = 'n', the normal interactive MOOG is run;
c     if silent = 'y', the non-interactive MOOG is run
      silent = 'y'


c*****invoke the overall starting routine
      control = '       '
      call begin

      If (fparam .eq. 'error') then
        temp = 'Please specify the input parameter file at the command'
        write (*,444) temp
444     format (A100)
        return
      endif

c*****use one of the standard driver routines ("isotop" is obsolete): 
c      if     (control .eq. 'synplot') then
c         call plotit
c      elseif (control .eq. 'isoplot') then
c         call plotit
c      elseif (control .eq. 'synth  ') then
c  ##### SYNTH ONLY #####
         call synth
c      elseif (control .eq. 'cogsyn ') then
c         call cogsyn  
c      elseif (control .eq. 'blends ') then
c         call blends  
c      elseif (control .eq. 'abfind ') then
c         call abfind
c      elseif (control .eq. 'ewfind ') then
c         call ewfind
c      elseif (control .eq. 'cog    ') then
c         call cog
c      elseif (control .eq. 'calmod ') then
c         call calmod
c      elseif (control .eq. 'isotop ') then
c         control = 'synth  '
c         call synth
c      elseif (control .eq. 'doflux ') then
c         call doflux   
c      elseif (control .eq. 'weedout') then
c         call weedout  
c      elseif (control .eq. 'gridsyn') then
c         call gridsyn  
c      elseif (control .eq. 'gridplo') then
c         call gridplo  
c      elseif (control .eq. 'binary ') then
c         call binary
c      elseif (control .eq. 'abpop  ') then
c         call abpop
c      elseif (control .eq. 'synpop ') then
c         call synpop


c*****or, put in your own drivers in the form below....
c      elseif (control .eq. 'mine  ') then
c         call  mydriver 


c*****or else you are out of luck!
c      else
c         array = 'THIS IS NOT ONE OF THE DRIVERS. I QUIT!'
c         istat = ivwrite (4,3,array,49)
c         stop
c      endif


c*****format statements
1001  format (60(' '))
1017  format ('x11 -bg black -title MOOGplot -geom 700x800+650+000')
1018  format ('x11 -bg black -title MOOGplot -geom 1200x400+20+450')


      end
      

      subroutine plotremember (option)
c******************************************************************************
c     This subroutine declares or stores or recovers the plotting parameters 
c     that were default, or set in the parameter file or were the ones used 
c     in the most recent call to a plotting routine.
c****************************************************************************** 

      include 'Linex.com'
      include 'Pstuff.com'
      integer option


c*****initialize the plot parameters; iscale=0 is simple default;
c     iscale=1 is when these parameters have been read from the
c     parameter file
      if     (option .eq. 0) then
         if (iscale .eq. 0) then
            xlo       = oldstart
            xhi       = oldstop
            ylo       = 0.
            yhi       = 1.1
            veladd    = 0.
            xadd      = 0.
            yadd      = 0.
            ymult     = 1.
            smtype    = 'g'
            fwhmgauss = 0.1
            vsini     = 0.
            limbdark  = 0.
            vmac      = 0.
            fwhmloren = 0.
            whichwin  = '1of1'
         endif


c*****store the original plot parameters
      elseif (option .eq. 1) then
         origxlo       = xlo
         origxhi       = xhi
         origylo       = ylo
         origyhi       = yhi
         origveladd    = veladd
         origxadd      = xadd
         origyadd      = yadd
         origymult     = ymult
         origsmtype    = smtype
         origfwhmgauss = fwhmgauss
         origvsini     = vsini
         origlimbdark  = limbdark
         origvmac      = vmac
         origfwhmloren = fwhmloren
         origwhichwin  = whichwin


c*****re-set the plot parameters to their original values
      elseif (option .eq. 2) then
         xlo       = origxlo
         xhi       = origxhi
         ylo       = origylo
         yhi       = origyhi
         veladd    = origveladd
         xadd      = origxadd
         yadd      = origyadd
         ymult     = origymult
         smtype    = origsmtype
         fwhmgauss = origfwhmgauss
         vsini     = origvsini
         limbdark  = origlimbdark
         vmac      = origvmac
         fwhmloren = origfwhmloren
         whichwin  = origwhichwin


c*****store the plot parameters from the last entry into pltspec
      elseif (option .eq. 3) then
         oldxlo       = xlo
         oldxhi       = xhi
         oldylo       = ylo
         oldyhi       = yhi
         oldveladd    = veladd
         oldxadd      = xadd
         oldyadd      = yadd
         oldymult     = ymult
         oldsmtype    = smtype
         oldfwhmgauss = fwhmgauss
         oldvsini     = vsini
         oldlimbdark  = limbdark
         oldvmac      = vmac
         oldfwhmloren = fwhmloren
         oldwhichwin  = whichwin


c*****re-set plot parameters to values from the last entry into pltspec
      elseif (option .eq. 4) then
         xlo       = oldxlo
         xhi       = oldxhi
         ylo       = oldylo
         yhi       = oldyhi
         veladd    = oldveladd
         xadd      = oldxadd
         yadd      = oldyadd
         ymult     = oldymult
         smtype    = oldsmtype
         fwhmgauss = oldfwhmgauss
         vsini     = oldvsini
         limbdark  = oldlimbdark
         vmac      = oldvmac
         fwhmloren = oldfwhmloren
         whichwin  = oldwhichwin
      else
         stop 'bad option in plotremember; I quit!'
      endif


      return
      end


      

      

      subroutine fakeline
c******************************************************************************
c     This routine creates a representative atomic line with parameters
c     that are arbitrarily set in this routine.  Then this line is used to
c     generate a curve-of-growth for use with the 'abfind' routine.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Quants.com'
      include 'Dampdat.com'


c*****specify the input parameters of a representative "fake" line; 
c*****here we use a real Fe I line because it has Barklem damping data
      wave1(1)   = 5006.126
      atom1(1)   = 26.0
      e(1,1)     = 2.833
      e(1,2)     = 5.308
      gf(1)      = 1.0e-3
      iatom      = atom1(1)
      charge(1)  = 1.0
      amass(1)   = xam(iatom)
      chi(1,1)   = xchi1(iatom)
      chi(1,2)   = xchi2(iatom)
      chi(1,3)   = xchi3(iatom)
      gammabk(1) = -7.280
      alphabk(1) = 0.238
      gambark(1) = 10.**gammabk(1)             
      alpbark(1) = (1.-alphabk(1))/2. 
      if     (dampingopt .eq. 0) then
         damptype(1) = 'UNSLDc6'
      elseif (dampingopt .eq. 1) then
         damptype(1) = 'BKgamma'
      elseif (dampingopt .eq. 2) then
         damptype(1) = 'BLKWLc6'
      else
         damptype(1) = 'NEXTGEN'
      endif


c*****do the partition function
      call partfn (atom1(1),int(atom1(1)+0.001))


c*****now calculate the dependent quantities, such as doppler parameters,
c     damping constant, line opacity at line center
      lim1line = 1 
      lim2line = 1 
      nlines   = 1
      idump = nf2out
      nf2out = 0
      call nearly (3)


c*****setting some counting parameters and do a curve-of-growth
      lim1     = 1
      lim2     = 1
      rwlow    = -6.7
      rwhigh   = -3.7
      rwstep   =  0.15
      call curve
      nf2out = idump


c*****make an interpolated curve-of-growth at very small log gf steps 
      do i=2,ncurve-2
         k = 30*(i-2)
         l = -1
         do m=k+1,k+30
           l = l + 1
           pp       = 0.005/0.15*(l-1)
           gftab(m) = gf1(2) + 0.005*(m-1)
           rwtab(m) = w(i-1)*(-pp)*(pp-1.)*(pp-2.)/6. +
     .                w(i)*(pp*pp-1.)*(pp-2.)/2. +
     .                w(i+1)*(-pp)*(pp+1.)*(pp-2.)/2. +
     .                w(i+2)*pp*(pp*pp-1.)/6.
         enddo
      enddo
      ntabtot = m - 1


c*****exit back to the abfind driver
      return
      end

      subroutine eqlib                                                  
c******************************************************************************
c     This routine solves the equations of molecular dissociative           
c     equilibrium. the equations can include neutral and ionized molecules  
c     and atoms 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Mol.com'
      include 'Quants.com'
      include 'Dummy.com'
      real*8 xfic(30), xcorr(30), deltax(30), c(30,30), ans(30,30)      
      real*8 uu(2)
      real*8 lth
      integer ident(30,110)


c*****clear the arrays 
      iorder(1) = 0                                                
      neq = iorder(1) 
      tdel = (t(ntau)-t(1))/4.0 + 1.0                                   
      do k=1,30                                                       
         iorder(k) = 0                                                  
         xcorr(k) = 0.                                                  
         do kk=1,110                       
            ident(k,kk) = 0                                             
         enddo
      enddo


c*****either read in the dissociation data for a molecular species
      do jmol=1,nmol                                                   
         if (amol(jmol) .ge. 100.) then
            do k=1,110                                                  
               if (datmol(1,k) .eq. amol(jmol)) go to 11                
            enddo
            write (nf1out,1001) amol(jmol)                   
            stop                                                        
11          do kk=1,6                                                   
               const(kk,jmol) = datmol(kk+1,k)                          
            enddo 


c*****or read the ionization data for an atomic species
         else
            iatom1 = amol(jmol) + 0.0001
            atom = iatom1                                            
            const(1,jmol) = xchi1(iatom1)                               
            do kk=1,5               
               ti = t(1) + (kk-1)*tdel 
               it = ti
               do jj=1,2
                  att = atom+0.1*(jj-1)
                  if (partflag(iatom1,jj) .gt. 0) then
                     uu(jj) = partnew(att,jj,it)
                  else
                     uu(jj) = ucalc(att,it)
                  endif
               enddo
               const(kk+1,jmol) = uu(2)/uu(1)
            enddo 
         endif
      enddo
      if (molopt .ge. 2) 
     .   write (nf1out,1002) (amol(i),(const(j,i),j=1,6),i=1,nmol)


c*****set up the molecular equilibrium array. each element of array         
c*****'ident' contains the identifier (subscript of an element of           
c*****array 'amol') of an ion or a molecule. the neutral atom is always     
c*****understood, but is not explicitly contained in 'ident'.               
      nmax = 1                                                          
      do jmol=1,nmol                                                  
         atom = amol(jmol)                                              
2        call sunder(atom,iatom1,iatom2)                                
         do k=1,30                                                      
            if (iatom1 .eq. iorder(k)) go to 4                          
         enddo
         neq = neq + 1                                                  
         iorder(neq) = iatom1                                           
         ident(neq,1) = jmol                                            
         go to 6                                                        
4        do kk=1,nmax                                                   
            if (ident(k,kk).eq.0 .or. ident(k,kk).eq. jmol) go to 7     
         enddo 
         nmax = nmax + 1                                                
         kk = nmax                                                
7        ident(k,kk) = jmol                                             
6        if (iatom2 .ne. 0) then
            atom = iatom2                                               
            go to 2                                                     
         endif
      enddo                                                           
      if (molopt .ge. 2) then
         do i=1,neq
            dummy1(i) = iorder(i)
         enddo
         write (nf1out,1003) (dummy1(i),i=1,neq),(amol(i),i=1,nmol)
      endif


c*****now begin the loop that goes through all the atmosphere tau layers
      do 21 kev=1,ntau                                                  


c*****calculate *xfic* and make a first guess at *xatom*                    
      i = ntau + 1 - kev                                           
      lev = i
      tk = 1.38054d-16*t(i)                                             
      do k=1,neq                                                      
         korder = iorder(k)                                             
         xfic(k) = xabund(korder)*nhtot(i)                              
      enddo
      if (i .lt. ntau) then
         do k=1,neq                                                     
            xatom(k) = xatom(k)*nhtot(i)/nhtot(i+1)                     
         enddo
      else
         do k=1,neq                                                     
            xatom(k) = xfic(k)                                          
         enddo
      endif


c*****compute the number of molecules:
c*****Here is some information about the equilibrium constants.
c*****The equilibrium constants, Kp, are defined as follows:
c
c
c                 P(A)*P(B)     N(A)*N(B)
c       Kp(AB)  = --------- = kT--------- =
c                  P(AB)         N(AB)
c
c             2*pi*kT 3/2    M(A)*M(B) 3/2   Q(A)*Q(B)
c       = kT*(-------)    * (---------)    * --------- * exp(-D(AB)/kT)
c               h^2            M(AB)           Q(AB)
c
c 
c*****MOOG uses: n(AB)/n(A)n(B) = kt/Kp
c 
c        Kp - dissociation constant, Q - partition functions, M - masses
c        P - partial pressures, N - number densities, T - temperature,
c        D - dissociation energy, h - plank constant. Remember to use
c        masses in grams (1 amu = 1.660540E-24 g) and energy in ergs
c        (1 eV = 1.60219E-12 ergs). Also, k = 1.38066E-16 erg/K,
c        h = 6.626076E-27 erg s, and pi = 3.1415926536.
27    do jmol=1,nmol                                                  
         atom = amol(jmol)                                              
         if (atom .ge. 100.) then
            if (t(i) .gt. 12000.) then
               xmol(jmol,i) = 1.0d-20
            else   
               xmol(jmol,i) = 1.
               count = 0.      
37             call sunder(atom,iatom1,iatom2)
               count = count + 1.            
               do k=1,neq                   
                  if (iorder(k) .eq. iatom1) 
     .               xmol(jmol,i) = xmol(jmol,i)*xatom(k)
               enddo                                    
               if (iatom2 .ne. 0) then
                  atom = iatom2                        
                  go to 37                                         
               endif
               hion = 10.0*(amol(jmol) - dint(amol(jmol)))  
               th = 5040./t(i)
               lth = log10(th)
               xmol(jmol,i) = xmol(jmol,i)*(((1.38066d-16 * t(i))**
     .             (count-1.0))/(10.0**(const(2,jmol)+(const(3,jmol)*
     .             lth)+(const(4,jmol)*(lth**2))+(const(5,jmol)*
     .             (lth**3))+(const(6,jmol)*(lth**4))-
     .             (const(1,jmol)*th))))/(ne(i)**hion)
            endif


c*****compute the number of ions:
         else
            delt = (t(i)-t(1))/tdel                               
            m = min0(idint(delt)+2,5)                          
            delt = delt - idint(delt)                           
             u1 = const(m,jmol) + 
     .           (const(m+1,jmol)-const(m,jmol))*delt          
            iatom1 = atom                                           
            do k=1,neq         
               if (iorder(k) .eq. iatom1) xmol(jmol,i) = 
     .            4.825d15*u1*t(i)**1.5/ne(i)*dexp(-1.1605d4* 
     .            const(1,jmol)/t(i))*xatom(k)               
            enddo
         endif
      enddo


c*****compute matrix *c*, which is the derivative of each equation with     
c*****respect to each atom.                                                 
      do k=1,neq                                                      
         deltax(k) = -xfic(k) + xatom(k)                                
         do kk=1,neq                                                    
            c(k,kk) = 0.                                                
         enddo
         c(k,k) = 1.                                                    
         korder = iorder(k)                                             
         do kk=1,neq                                                    
            kderiv = iorder(kk)                                         
            do 28 j=1,nmax                                              
               jmol = ident(k,j)                                        
               if (jmol .eq. 0) go to 28                                
               call discov(amol(jmol),kderiv,num2)                      
               if (num2 .eq. 0) go to 28                                
               call discov(amol(jmol),korder,num1)                      
               c(k,kk) = c(k,kk) + xmol(jmol,i)*num1*num2/xatom(kk)     
               if (k .eq. kk) deltax(k) = deltax(k) + num1*xmol(jmol,i) 
28          continue                                                    
         enddo
      enddo


c*****calculate array 'xcorr', the change in 'xatom'. array 'xcorr' is      
c*****'deltax' multiplied by the inverse of 'c'                            
      call invert (neq,c,ans,30)                                        
      do k=1,neq                                                      
         x1 = xcorr(k)                                                  
         xcorr(k) = 0.                                                  
         do kk=1,neq                                                    
            xcorr(k) = xcorr(k) + ans(k,kk)*deltax(kk)                  
         enddo
      enddo


c*****decide if another iteration is needed                                 
      iflag = 0                                                         
      do k=1,neq                                                      
c*****here oscillations are damped out                                      
         if (x1*xcorr(k) .lt. -0.5*x1**2) xcorr(k) = 0.5*xcorr(k)       
         x1 = xatom(k)                                                  
         if (dabs(xcorr(k)/xatom(k)) .gt. 0.005) iflag = 1              
         xatom(k) = xatom(k) - xcorr(k)                                 
c*****fix element number densities which are ridiculous                     
         if (xatom(k).le.0.0 .or. xatom(k).ge.1.001*xfic(k)) then
            iflag = 1                                                   
            xatom(k) = 1.0d-2*dabs(xatom(k)+xcorr(k))                   
         endif
      enddo                                                           
      if (iflag .ne. 0) go to 27                                        


c*****print out atomic and molecular partial pressures. *xamol* is the      
c*****number density for each neutral atom                                  
      do k=1,neq                                                     
         xamol(k,i) = xatom(k)                                          
         patom(k) = dlog10(xatom(k)*tk)                                 
      enddo
      do jmol=1,nmol                                                 
         pmol(jmol) = dlog10(xmol(jmol,i)*tk)                           
      enddo
      if (molopt .ge. 2) then
         pglog = dlog10(pgas(lev))
         write (nf1out,1004) lev,int(t(lev)+0.001),pglog,
     .                       (patom(i),i=1,neq), (pmol(i),i=1,nmol)
      endif


c*****here the big loop in tau ends
21    continue                                                          
      return                                                            


c*****format statements
1001  format ('I do not know this molecule: ',f10.0)              
1002  format (/'INPUT EQUILIBRIUM DATA:'/1x, 'species', 2x, 
     .        'D0/Chi ', 3x, 'const1', 6x, 'const2', 6x,
     .        'const3', 6x, 'const4', 6x, 'const5'/
     .        (0pf8.1, f8.3, 1p5d12.4))
1003  format (/'MOLECULAR EQUILIBRIUM SOLUTIONS:  (log partial',
     .        ' pressures listed under names)'/
     .        2x,'i',5x,'T',2x,'Pgas',8f8.1/(15x,8f8.1))
1004  format (i3,i6,f6.2,8f8.2/(15x,8f8.2))

      end                                                               

      subroutine calmod                   
c******************************************************************************
c     this program re-calculates BEGN models on a tau5000 scale.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'


c*****open the files for standard output and the re-calculated model
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'RE-CALCULATED MODEL OUTPUT'
      nchars = 26
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****do the tau scale conversion
      call opacit(2,wavref)   
      write (nf2out,1001) wavref,(taulam(i),t(i),pgas(i),
     .                ne(i),kaplam(i),i=1,ntau)
      return


c*****format statements
1001  format ('output model for wavelength = ',f5.0/
     .        (1pe11.4,0pf7.0,1p3e11.4))


      end              

      subroutine cogplot
c******************************************************************************
c     This subroutine creates plots of curves-of-growth
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      real*4 gfplot(3000), rwplot(3000)
      real*4 xfour, style(1)
      character*4 ion


c*****dump the data into working arrays
      do i=1,ncurve
         gfplot(i) = gf1(i)
         rwplot(i) = w(i)
      enddo


c*****define the plot boundaries
      ylo = real(nint(rwlow*10))/10. - 0.1
      yhi = real(nint(rwhigh*10))/10. + 0.1
      do i=1,ncurve
         if (rwplot(i) .gt. rwlow) then
            if (gfplot(i) .gt. 0) then
               xlo = real(int(gfplot(i)*10))/10
            else
               xlo = real(int(gfplot(i)*10))/10 - 0.1
            endif
            go to 10
         endif
      enddo
10    do i=1,ncurve
         if (rwplot(i) .gt. rwhigh) then
            if (gfplot(i) .gt. 0) then
               xhi = real(int(gfplot(i)*10))/10 + 0.1
            else
               xhi = real(int(gfplot(i)*10))/10
            endif
         endif
      enddo


cc*****start the plot via some setup calls
c      call sm_limits (xlo,xhi,ylo,yhi)
c      smlxtic = 0.20
c      smlytic = 0.20
c      bigxtic = 1.0
c      bigytic = 1.0
c      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
c 
c 
cc*****draw and label the box for the curve-of-growth
c      call sm_expand (0.6)
c      call sm_lweight (1.4)
c      call defcolor (1)
c      call sm_box (0,0,0,0)
c      call sm_expand (0.85)
c      call sm_box (1,2,4,4)
c      array = 'log gf'
c      call sm_relocate (0.5*(xlo+xhi),ylo-0.10*(yhi-ylo))
c      call sm_putlabel (5,array)
c      array = 'log (EW/lambda)'
c      call sm_relocate (xlo-0.06*(xhi-xlo),0.5*(yhi+ylo))
c      call sm_angle (90.)
c      call sm_putlabel (5,array)
c      call sm_angle (0.)
c      call sm_ltype (1)
c      call sm_lweight (0.8)
c      call sm_grid (0,0)
c      call sm_ltype (0)
c
c
cc*****plot the computed curve-of-growth points; exit normally
c      call sm_expand (1.05)
c      call defcolor (2)
c      style(1) = 240.7
c      call sm_ptype (style,1)
c      call sm_points (gfplot,rwplot,ncurve)
c      call defcolor (1)
c      ich = idint(charge(lim1) + 0.1)
c      if (ich .eq. 1) then
c         ion = ' I  '
c      elseif (ich .eq. 2) then
c         ion = ' II '
c      elseif (ich .eq. 3) then
c         ion = ' III'
c      endif
c      iatom = idint(atom1(lim1))
c      write (array,1002) names(iatom),ion
c      call sm_expand (0.75)
c      call sm_relocate (xhi-0.20*(xhi-xlo),ylo+0.35*(yhi-ylo))
c      call sm_putlabel (5,array)
c      call sm_relocate ((xhi+xlo)/2.0,yhi-0.03*(yhi-ylo))
c      call sm_putlabel (5,moditle)
c      xfour = dlog10(xabund(iatom)) + 12.0
c      write (array,1003) xfour
c      call sm_relocate (xhi-0.20*(xhi-xlo),ylo+0.27*(yhi-ylo))
c      call sm_putlabel (5,array)
c      write (array,1005) wave1(lim1)
c      call sm_relocate (xhi-0.20*(xhi-xlo),ylo+0.19*(yhi-ylo))
c      call sm_putlabel (5,array)
c      write (array,1004) e(lim1,1) 
c      call sm_relocate (xhi-0.20*(xhi-xlo),ylo+0.11*(yhi-ylo)) 
c      call sm_putlabel (5,array)
      return


c*****format statements
1002  format (a2,a4)
1003  format ('log eps =',f7.3)
1004  format ('E.P. (eV) =',f7.3) 
1005  format ('lambda (A) =',f11.3)

      end

      subroutine sourcefunc_scat_cont
c*************************************************************************
c     Calculates the *CONTINUUM* source function which incorporates both a
c     scattering and an absorption component.  The relevant quantities are S_cont (source function),
c     J_cont (the mean intensity), and Flux_cont (the total flux).  Employs the short characteristics methodology
c     for the solution of radiative transfer.
c*************************************************************************
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Source.com'
      data jentry /0/

c***  Local Arrays/Variables
      real*8  Thomson_cont(100)
      real*8  ddm(100), alo(100), ood(100)
      real*8  eta(100), etat(100)
      real*8  Scat_opacity(100) 
      real*8  ddmm(100), dtau1MI(100) 
      real*8  Therm_opacity(100)
      real*8  dtau(100), WOP(100), W1(100), W0(100)
      real*8  J_cont_OLD(100)
      real*8  J_cont_moog(100), S_cont_moog(100)
      real*8  exptau2(100)
      integer IT
c     real*8  J_cont(100), S_cont(100)

c*** DETERMINE: rhox for MODELS that do not contain these values.  An additional constant might be necessary as kappa does vary.
      do i=1, ntau
         if (modtype .eq. 'KURTYPE   ' .or.
     >       modtype .eq. 'KURUCZ    ' .or.
     >       modtype .eq. 'WEBMARCS  ') cycle
         rhox(i) = tauref(i)/(kapref(i)/rho(i))
      enddo   

c*** INTEGRATION IN MU: Call the AngWeight.f subroutine (Gaussian Quadrature Summation).
c    During initial pass, calculate the Gaussian integration points and weights.
c    AngWeight.f operates ONLY with odd numbers of rays (mmu = 1, 3, 5,...).  Should correct this.
c    Note that with increasing ray number (>= 5), the mu value more closely approaches 1. 
      if (jentry .eq. 0) then
         mmu = 5
         aaa = 0.
         bbb = 1.
         call AngWeight (mmu,aaa,bbb,wtmu,mu)
               xxx = 0
               do i=1,mmu
                   xxx = xxx + wtmu(i)
               enddo
         jentry = 1     
      endif

c*** SET-UP: delta_tau variable (name: dtau1).
      do i=1, ntau
        ood(i)     = kaplam(i) / rho(i)
        if (i .eq. 1)  cycle
        ddm(i)     = 0.5 * abs((rhox(i) - rhox(i-1)))
        dtau1(i)   = ddm(i) * (ood(i-1) + ood(i))
        if (i .eq. ntau) cycle
c        ddmm(i)    = 0.25 * (rhox(i+1) - rhox(i-1))
c        dtau1MI(i) = 1. / (ddmm(i) * (ood(i-1) + ood(i+1)))
      enddo

c*** SET-UP: Scat_opacity, Therm_opacity, and Thomson terms.  
c    Note the S_cont determination includes ONLY continuum-associated quantities.
c    As is standard, Therm_opacity(i) = kaplam(i) - Scat_opacity(i).
      do i=1, ntau
         Scat_opacity(i)  = kaplamsca(i)
         Therm_opacity(i) = kaplamabs(i)
         Thomson_cont(i)  = Scat_opacity(i)/kaplam(i)
      enddo

c*** ACCELERATION OF CONVERGENCE: To accelerate the convergence of the solution of the RTE, it is necessary to employ the technique of 
c    accelerated lambda iteration (ALI).  The steps below set-up the lambda operator.  
c    Convergence Requirements (original values: Converg_iter = 1.e-5 and Max_iter = 25):
      Converg_iter = 2.E-3
      Max_iter     = 65
c     Gamma controls the amount of acceleration.
c     Gamma = 0 : No Acceleration
c           = 1 : Full Acceleration
c           > 1 : Acceleration with damping  
      gamma = 1.
      if (gamma .eq. 0.) then
         do i=1, ntau
           alo(i) = 1.
         enddo
      else
        do i=1, ntau
          if (i .eq. 1) then
            dtau_alo = dtau1(2)
          else if (i .eq. ntau) then
            dtau_alo = 0.5 * dtau1(ntau)                                         | APPLY necessary additonal damping for the inner boundary
          else
            dtau_alo = 0.5 * (dtau1(i) + dtau1(i+1))                             | COMMENT: sum (/integral) of 1/mu * dmu = Sum of mu * dmu = 0.5
          endif
          dtau_alo = dtau_alo * Thomson_cont(i) / (2. * gamma)                   | EMPLOY the damping factor of 2. * gamma (alternate: dtau_alo = dtau_alo * 1. /)
          exp_dtau_alo = exp(-dtau_alo)                                          | CREATE lambda operator with above-listed THOMSON factor
          if (exp_dtau_alo .ne. 1.) then
            alo(i) = dtau_alo / (1. - exp(-dtau_alo))
          else
            alo(i) = 1.
          endif
        enddo
      endif

c***  SET-UP: Fundamental Quantities (e.g., emissivity from planck function)
      Const1       = 1.43878858E08
      Const2       = 3.972610376E08
      H_cont       = Const1/wave
      H_cont_core  = H_cont/t(ntau)
      B_core       = Const2/((exp(H_cont_core)-1.)*wave*wave*wave)
      H_cont_core1 = H_cont/ t(ntau-1)
      B_core1      = Const2/((exp(H_cont_core1)-1.)*wave*wave*wave)
      DB_core      = B_core-B_core1

c***  SET-UP: Critical parameters such as the Planck Function (B), the Initial Mean Intensity (J_cont_OLD), etc.
      do i=1, ntau
        H_cont_t      = H_cont / t(i)
        B_planck(i)   = Const2 / ((exp(H_cont_t)-1.)*wave*wave*wave)
        J_cont_OLD(i) = B_planck(i)
        eta(i)        = B_planck(i) * Therm_opacity(i)
        etat(i)       = Scat_opacity(i) * J_cont_OLD(i)
        S_cont_CF(i)  = (eta(i)+etat(i))/kaplam(i)
      enddo
 
c     ---------------------------------
c***  START of the main ITERATION loop
c     ---------------------------------
      IT   = 0
      do
        IT = IT + 1
        do i=1,ntau
           J_cont_OLD(i)  = J_cont(i)
           J_cont(i)      = 0.
           S_cont(i)      = (eta(i) + etat(i)) / kaplam(i)
        enddo
c     -------------------------
c***  START of the ANGLE loop
c     -------------------------
        Flux_cont  = 0.  
        do j=1, mmu
          XI = 0.                                                          | NO INCIDENT RADIATION
          do i=2, ntau                                                     | BEGIN Depth Loop: Integration Inwards
            dtau(i)   = dtau1(i) / mu(j)
            exptau    = dexp(-dtau(i))
            WOP(i)    = (exptau - 1.) / dtau(i)
            W0(i)     = 1. + WOP(i)
            W1(i)     = -exptau - WOP(i)
            XI        = XI*exptau + W0(i)*S_cont(i) + W1(i)*S_cont(i-1)
            J_cont(i) = J_cont(i) + 0.5 * wtmu(j) * XI
          enddo                                                            | End Depth Loop  
          XI = 0.5 * wtmu(j) * (B_core+(DB_core*mu(j)/dtau1(ntau)))        | PREPARE Inner Boundary: multiplied by 2/dtau
          J_cont(ntau) = J_cont(ntau) + XI                                 | SET Inner Boundary Condition
          do i=ntau-1, 1, -1                                               | BEGIN Depth Loop: Integration Outwards
            dtau(i)   = dtau1(i+1) / mu(j)
            exptau    = dexp(-dtau(i))
            WOP(i)    = (exptau - 1.) / dtau(i)
            W0(i)     = 1. + WOP(i)
            W1(i)     = -exptau - WOP(i)
            XI        = XI*exptau + W0(i)*S_cont(i) + W1(i)*S_cont(i+1)
            J_cont(i) = J_cont(i) + 0.5 * wtmu(j) * XI
          enddo                                                             | End Depth Loop 
          Flux_cont    = Flux_cont + XI * 0.5 * wtmu(j) * mu(j)             | CALCULATE Emergent Flux (CRITICAL OUTPUT QUANTITY!)
c     ------------------
c***  END of ANGLE Loop
c     ------------------
        enddo

c***  ACCELERATION OF CONVERGENCE: Calculate new etat and prepare to exit iteration loop (note ALI applied)
        q_max = 0.
        i_max = 0.
        do i=1, ntau
          etat_new = Scat_opacity(i) * J_cont(i)                              | SET-UP the etat_new quantity
          DE       = etat_new - etat(i)                                       | DETERMINE new value of delta(etat)
          DE       = DE * alo(i)                                              | APPLY acceleration to delta(etat)
          etat_new = etat(i) + DE                                             | CALCULATE the "accerlerated" etat_new quantity 
          QNA      = (etat_new - etat(i)) / etat_new                          | COMPUTE convergence_quantity_1 
          Q        = ABS(etat_new - etat(i)) / etat_new                       | COMPUTE convergence_quantity_2
          if (Q .gt. q_max) then
            q_max   = Q
            q_maxNA = QNA
            i_max   = i
          endif
          etat(i) = etat_new                                                   | SET-UP and pass the iterated etat quantity to next loop
        enddo
        if (q_max .le. Converg_iter .or. Max_iter .eq. 1) exit                 | DETERMINE if convergence requirements met and EXIT routine (IMPT. STEP!)
        if (IT .ge. Max_iter) then                                             | NOTIFY user if the maximum number of iterations exceeded
           write (0, '(A)') 
     >       'Maximum number of iterations exceeded : wave, q_max= '
           write (0,'(F12.5,1p7e10.2)') wave, q_max
           write (0,'(I3,I3)') i_max, ntau
!          write (0,'(A,F12.5,1X,1p7e10.2,1X,I3,1X,I3)')           
!     >      'Maximum number of iterations exceeded : wave, q_max= ',
!     >      wave, q_max, i_max, ntau
          exit                                                                 | EXIT routine if maximum number of iterations exceeded
        endif
c     -----------------------
c***  END of ITERATION loop
c     -----------------------
      enddo


c***  CONVERT variables to MOOG/Edmonds format/units (if desired).
       do i=1,ntau
          S_cont_moog(i) = 2.9977518E26*(1/(wave**2))
     >                *S_cont(i)
          J_cont_moog(i) = 2.9977518E26*(1/(wave**2))
     >                *J_cont(i)
       enddo
       Flux_cont_moog = 2.9977518E26*(1/(wave**2))
     >             *Flux_cont

c     ---------------------
c***  END of ROUTINE
c     ---------------------           
      return
      end


c***  Tabulation of the flux due to pure absorption (not requisite).
c      Flux_pureabs = Flux_pureabs + B_planck(1)
c      Flux_pureabs_moog =  2.9977518E26*(1/(wave**2))
c     >             *Flux_pureabs

      subroutine specplot
c******************************************************************************
c     This routine produces MONGO plots of the syntheses.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Quants.com'
      include 'Factor.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Multistar.com'
      real*4 style(1)
      real*4 yup,ydown
      integer iflip


c*****for grid syntheses, dump out relevant information to a file
      if (choice .eq. 'g') then
         write (nf6out,3001) syncount
         write (nf6out,3002) obsitle, moditle, linitle, smitle
      endif
 

cc*****begin with a default window
c      call sm_location (3500,31000,4000,30000)
c      call sm_window (1,1,1,1,1,1)
c      call sm_limits (0.0,1.0,0.0,1.0)
c      call defcolor (1)
c
c
cc*****write smoothing information at the top of the plot
c      call sm_lweight (2.2)
c      call sm_expand (0.7)
c      call sm_relocate (-0.120,1.015)
c      call sm_label (smitle)
c
c
c      if (isoitle(1:10) .eq. '          ') then
c         isoitle(1:16) = 'no isotopic data'
c      endif
c      call sm_relocate (-0.120,1.075)
c      call sm_label (isoitle(1:120))
c      if (numiso .gt. 3) then
c         call sm_relocate (-0.120,1.045)
c         call sm_label (isoitle(121:240))
c      endif
c      if (control .eq. 'gridplo' .or.
c     .    control .eq. 'gridsyn' .or.
c     .    control .eq. 'gridend') then
c         write (nf6out,3002) isoitle(1:120)
c         write (nf6out,3002) isoitle(121:240)
c      endif
c 
c
cc*****define the real plot limits
c      if (xlo .lt. xhi) then
c         call sm_limits (xlo,xhi,ylo,yhi)
c         iflip = 0
c      else
c         call sm_limits (xhi,xlo,ylo,yhi)
c         iflip = 1
c      endif
c      call findtic (xlo,xhi,bigxtic,smlxtic)
c      call findtic (ylo,yhi,bigytic,smlytic)
c      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
c
c
cc*****draw and label the box for the spectra
c      call defcolor (1)
c      if (whichwin .eq. '1of1') then
c         idev = 1
c         call sm_window (1,1,1,1,1,1)
c      else
c         idev = 2
c         call sm_defvar ('y_gutter','0.0')
c         call sm_window (1,2,1,1,1,1)
c      endif
c      call sm_lweight (4.0)
c      call sm_expand (1.2)
c      call sm_box (0,0,0,0)
c      call sm_lweight (2.0)
c      call sm_expand (0.8)
c      call sm_box (1,2,4,4)
c      if (iflip .eq. 1) then
c         array = 'Wavenumber'
c      else
c         array = 'Wavelength'
c      endif
c      call sm_xlabel (array)
c      array = 'Rel  Flux'
c      call sm_ylabel (array)
c
c
cc*****plot the synthetic spectra
c      call sm_lweight (2.2)
c      call sm_expand (0.7)
c      do i=1,100
c         if (pec(i) .ne. 0) go to 111
c      enddo            
c111   do j=1,nsyn
c         if (choice.eq.'h' .or. choice.eq.'f' .or.
c     .       choice.eq.'g') then
c            call defcolor (8)
c            call sm_ltype (j-1)
c         else
c            if (smterm(1:3) .eq. 'x11') then
c               call defcolor (j+1)
c               call sm_ltype (0)
c            else
c               call defcolor (1)
c               call sm_ltype (j-1)
c            endif
c         endif
c         call sm_connect (xsyn,chunk(1,j),kount) 
c         if (iflip .eq. 1) then
c            call sm_relocate (xhi+0.045*(xlo-xhi),
c     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
c            call sm_draw (xhi+0.005*(xlo-xhi),
c     .                 ylo+(0.12+0.06*j)*(yhi-ylo))
c            call sm_relocate (xhi+0.05*(xlo-xhi),
c     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
c         else
c            call sm_relocate (xlo+0.045*(xhi-xlo),
c     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
c            call sm_draw (xlo+0.005*(xlo-xhi),
c     .                 ylo+(0.12+0.06*j)*(yhi-ylo))
c            call sm_relocate (xlo+0.05*(xhi-xlo),
c     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
c         endif
c         noff = 80*(j-1)
c         call sm_lweight (2.2)
c         call sm_label (abitle(noff+1:noff+80))
c         if ((control .eq. 'gridplo' .or.
c     .        control .eq. 'gridsyn' .or.
c     .        control .eq. 'gridend') .and. 
c     .        whichwin.eq.'1of1') then
c            write (nf6out,3002) abitle(noff+1:noff+80)
c         endif
c      enddo
c      call defcolor (1)
c      call sm_ltype (0)
c
c   
cc*****plot the observed spectrum
c      if (plotopt .eq. 2) then
c         call defcolor (1)
c         if (choice.eq.'h' .or. choice.eq.'f' .or.
c     .       choice.eq.'g') then
c            call sm_lweight (4.0)
c         else 
c            call sm_lweight (2.2)
c         endif
c         call sm_ltype (0)
c         call sm_expand (3.0)
c         style(1) = 43.5
c         call sm_ptype (style,1)
c         mount = lim2obs - lim1obs + 1
c         if (mount .lt. 500) then
c            call sm_points (xobs(lim1obs),yobs(lim1obs),mount)
c         else
c            if (histoyes .eq. 1) then
c               call sm_histogram (xobs(lim1obs),yobs(lim1obs),mount)
c            else
c               call sm_connect (xobs(lim1obs),yobs(lim1obs),mount)
c            endif
c         endif
c         call sm_lweight (2.2)
c         call sm_expand (0.7)
c         if (iflip .eq. 1) then
c            call sm_relocate (xhi+0.05*(xlo-xhi),ylo+0.12*(yhi-ylo))
c         else
c            call sm_relocate (xlo+0.05*(xhi-xlo),ylo+0.12*(yhi-ylo))
c         endif
c         call sm_label (obsitle)
c      endif
c      if (iflip .eq. 1) then
c         call sm_relocate (xhi+0.05*(xlo-xhi),ylo+0.06*(yhi-ylo))
c      else
c         call sm_relocate (xlo+0.05*(xhi-xlo),ylo+0.06*(yhi-ylo))
c      endif
c      call sm_label (moditle)
c      if (whichwin.eq.'1of1' .or. plotopt.ne.2) then
c         return
c      endif
c
c
cc*****this section of code is executed only if a deviations plot is desired;
cc     find the starting and stopping points in the arrays for the deviations
c      if (xsyn(kount) .le. xobs(lim1obs)) go to 1000
c      if (xsyn(1) .gt. xobs(lim2obs)) go to 1000
c      if (xsyn(1) .gt. xobs(lim1obs)) go to 150
c      lim3obs = lim1obs
c      do k=2,kount
c         if (xsyn(k) .gt. xobs(lim3obs)) then
c            lim1syn = k - 1
c            go to 155
c         endif
c      enddo
c150   lim1syn = 1
c      do l=lim1obs,lim2obs
c         if (xsyn(lim1syn) .le. xobs(l)) then
c            lim3obs = l 
c            go to 155
c         endif
c      enddo
c155   if (xsyn(kount) .lt. xobs(lim2obs)) go to 160
c      lim4obs = lim2obs
c      do k=lim1syn,kount
c         if (xsyn(k) .gt. xobs(lim4obs)) then
c            lim2syn = k
c            go to 165
c         endif
c      enddo
c160   lim2syn = kount
c      do l=lim3obs,lim2obs
c         if (xsyn(lim2syn) .lt. xobs(l)) then
c            lim4obs = l - 1
c            go to 165
c         endif
c      enddo
c
c
cc  compute the deviations; linear interpolation in the wavelength array
cc  of the synthetic spectra is considered sufficient
c165   do j=1,nsyn
c         lpoint = lim1syn
c         devsigma = 0.
c         do i=lim3obs,lim4obs
c170         if (xsyn(lpoint+1) .lt. xobs(i)) then
c               lpoint = lpoint + 1
c               go to 170
c            endif
c            syninterp = (chunk(lpoint+1,j)-chunk(lpoint,j))*
c     .         (xobs(i)-xsyn(lpoint))/(xsyn(lpoint+1)-xsyn(lpoint)) +
c     .         chunk(lpoint,j)
c            dev(i) = yobs(i) - syninterp
c            devsigma = devsigma + dev(i)**2
c         enddo
c         devsigma = dsqrt(devsigma/(lim4obs-lim3obs-1))
c         
c      
cc  from first set of deviations, define the plot limits, draw and label box
c         if (j .eq. 1) then
c            yup = -1000.
c            ydown = +1000.
c            do i=lim3obs,lim4obs
c               yup = amax1(yup,dev(i))
c               ydown = amin1(ydown,dev(i))
c            enddo
c            ydelta = amin1(0.3,amax1(0.05,1.5*(yup-ydown)/2.))
c            ydown = -ydelta
c            yup = ydelta
c            call sm_defvar ('y_gutter','0.0')
c            call sm_window (1,2,1,2,1,2)
c            call sm_limits (xlo,xhi,ydown,yup)
c            call findtic (ydown,yup,bigytic,smlytic)
c            call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
c            call sm_lweight (4.0)
c            call sm_expand (1.2)
c            call defcolor (1)
c            call sm_box (0,0,0,0)
c            call sm_lweight (2.0)
c            call sm_expand (0.8)
c            call sm_box (4,2,4,4)
c            array = 'Obs - Comp'
c            call sm_ylabel (array)
c            call sm_relocate (xlo,0.0)
c            call sm_draw (xhi,0.0)
c         endif
c
c
cc  plot the array of deviations
c         if (choice.eq.'h' .or. choice.eq.'f' .or.
c     .       choice.eq.'g') then
c            call defcolor (8)
c            call sm_ltype (j-1)
c         else
c            if (smterm(1:3) .eq. 'x11') then
c               call defcolor (j+1)
c               call sm_ltype (0)
c            else
c               call defcolor (1)
c               call sm_ltype (j-1)
c            endif
c         endif
c         call defcolor (j+1)
c         call sm_lweight (2.2)
c         call sm_connect (xobs(lim1obs),dev(lim1obs),mount)
c         write (array,1021) devsigma
c         call sm_relocate(xhi-0.2*(xhi-xlo),
c     .                 ydown+(0.10+0.06*j)*(yup-ydown))
c         call sm_relocate(xhi-0.24*(xhi-xlo),
c     .                 ydown+(0.10+0.06*j)*(yup-ydown))
c         call sm_draw(xhi-0.215*(xhi-xlo),
c     .                 ydown+(0.10+0.06*j)*(yup-ydown))
c         call sm_label (array)
c         if (choice .eq. 'g') then
c            noff = 80*(j-1)
c            write (nf6out,3002) abitle(noff+1:noff+80)
c            write (nf6out,3003) devsigma, velsh
c         endif
c      enddo
c
c
cc  reset the spectrum plot boundaries before exiting
c      if(xlo .lt. xhi) then
c         call sm_limits (xlo,xhi,ylo,yhi)
c         iflip = 0
c      else
c         call sm_limits (xhi,xlo,ylo,yhi)
c         iflip = 1
c      endif
1000  return


c*****format statements
1021  format ('sigma =',f7.4)
3001  format (/'RUN NUMBER:', i4, 65('-'))
3002  format (a80)
3003  format ('sigma =',f8.5, '   lambda shift =',f7.3,' km/s')


      end

      subroutine begin
c***************************************************************************
c     This routine simply starts up MOOG
c     THIS VERSION IS FOR LINUX REDHAT MACHINES
c***************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'
      character*80 line, systemcall
      integer num


c*****define the number of text screen lines for silent mode;
c     this number is hardwired, since it is not really needed at run time.
      if (silent .eq. 'y') then
         maxline = 24
         go to 10
      endif


c*****define the number of lines available on the text screen for
c     interactive mode; this number is discovered from the "stty -a"
c     command, for which the output format is unique to the operating
c     system.
      write (systemcall,*) 'stty -a > tmpsize'
      call system (systemcall)
      open (99,file='tmpsize')
5     read (99,1010,end=15) line
      do i=1,77
         if (line(i:i+3) .eq. 'rows') then
            if     (machine .eq. 'pcl') then
               read (line(i+4:i+6),1011) maxline
            elseif (machine .eq. 'mac') then
               read (line(i-4:i-2),1011) maxline
            elseif (machine .eq. 'uni') then
               read (line(i+6:i+8),1011) maxline
            endif
            go to 10
         endif
      enddo
      go to 5
15    array = 'SCREEN ROW COUNT UNKNOWN; USE 24 ([y]/n)? '
      nchars = 42
      ikount = 2
      call getasci (nchars,ikount)
      choice = chinfo(1:1)
      if (choice.eq.'y' .or. nchars.le.0) then
         go to 10
      else
         call finish (0)
      endif
10    close (99,status='delete')
      write (systemcall,*) '\\rm -f tmpsize'
      call system (systemcall)
      if (maxline .lt. 10) then
         maxline = 24
      else
         maxline = maxline - 2
      endif


c*****clear the text screen
      write (systemcall,*) 'clear'
      call system (systemcall)


c*****open data files carried with the source code: Barklem damping
      nfbarklem = 35
      num = 60
      call getcount (num,moogpath)
      if (moogpath(num:num) .ne. '/') then
         num = num + 1
         moogpath(num:num) = '/'
      endif
c      fbarklem(1:num) = moogpath(1:num)
c      fbarklem(num+1:num+11) = 'Barklem.dat'
c      open (nfbarklem,file=fbarklem)
      open (nfbarklem,file='$DATADIR/Barklem.dat')

c*****open data files carried with the source code: Barklem UV damping
      nfbarklemUV = 36
      num = 60
      call getcount (num,moogpath)
      if (moogpath(num:num) .ne. '/') then
         num = num + 1
         moogpath(num:num) = '/'
      endif
c      fbarklemUV(1:num) = moogpath(1:num)
c      fbarklemUV(num+1:num+13) = 'BarklemUV.dat'
c      open (nfbarklemUV,file=fbarklemUV)
      open (nfbarklemUV,file='$DATADIR/BarklemUV.dat') 

c  write a header and find the appropriate parameter file, and exit normally
      write (array,1001)
      istat = ivwrite (1,1,array,79)
      write (array,1004)
      istat = ivwrite (2,1,array,79)
      array = 'MOOG PARAMETERS? ' 
      nchars = 15
      nfparam = 50     
      lscreen = 4
      if (silent .eq. 'y') then
         fparam = 'batch.par'
      else
         fparam = 'no_filename_given'     
      endif
      call infile ('input  ',nfparam,'formatted  ',0,nchars,
     .             fparam,lscreen)
      read (nfparam,1002) control
      write (array,1003) control
      istat = ivwrite (2,1,array,58)
      write (array,1001)
      istat = ivwrite (3,1,array,79)
      return


c*****format statements
1001  format (79('*'))
1002  format (a7)
1003  format (22x,'MOOG IS CONTROLLED BY DRIVER ',a7)
1004  format (25(' '),'MOOG LTE VERSION (FEB 2017)',26(' '))   
1010  format (a80)
1011  format (i3)


      end
      

      subroutine estim (xleft,right,a,wl,npts,ileft,iright)
c******************************************************************************
c     This routine returns channel (pixel) values
c******************************************************************************
 
      real*4 wl(1)
      real*8 a(9)

 
      if (a(9).eq.1 .or. a(9).eq.2 .or. a(9).eq.3) go to 40
      if (a(4).eq.0.0 .and. a(3).eq.0.0) go to 60
  

c*****do the estimation for quadratics and cubics
      ileft = int(sngl((-a(2) + dsqrt(a(2)**2-4.*a(3)*(a(1)-xleft)))/
     . (2.*a(3)) - 0.5))
      iright = int(sngl((-a(2) + dsqrt(a(2)**2-4.*a(3)*(a(1)-right)))/
     . (2.*a(3)) + 0.5))

      if (a(4) .ne. 0.) then
         ipt = max0(ileft-3,1)
         jpt = min0(ileft+3,npts)
         ileft = ipt + int(6.*(xleft-wl(ipt))/(wl(jpt)-wl(ipt)))
         ipt = max0(iright-3,1)
         jpt = min0(iright+3,npts)
         iright = ipt + int(6.*(right-wl(ipt))/(wl(jpt)-wl(ipt)))
      endif
      ileft = max0(1,ileft)
      iright = min0(npts,iright)
      return


c*****do the estimation for linears
60    if (a(2) .eq. 0.) then
         ileft = int(xleft)
         iright = int(right)
      else
         ileft = max0(1,int(sngl((xleft-a(1))/a(2))))
         iright = min0(npts,int(sngl((right-a(1))/a(2))))
      endif
      return


c*****do the estimation for Chebyshevs, Splines, and Legendres
40    if (xleft .lt. wl(1)) then
         ileft = 1
         go to 55
      endif
      do i=2,npts
         if (xleft .le. wl(i)) then
            if (abs(xleft-wl(i)) .gt. abs(xleft-wl(i-1))) then
               ileft = i-1
            else
               ileft = i
            endif
            go to 55
         endif
      enddo        
55    if (right .gt. wl(npts)) then
         iright = npts
         return
      endif
      do i=npts-1,1,-1
         if (right .ge. wl(i)) then
            if (abs(right-wl(i)) .gt. abs(right-wl(i+1))) then
               iright = i+1
            else
               iright = i
            endif
            return
         endif
      enddo     
      return
               

      end

      subroutine specplot
c******************************************************************************
c     This routine produces MONGO plots of the syntheses.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Quants.com'
      include 'Factor.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Multistar.com'
      real*4 style(1)
      real*4 yup,ydown
      integer iflip


c*****for grid syntheses, dump out relevant information to a file
      if (choice .eq. 'g') then
         write (nf6out,3001) syncount
         write (nf6out,3002) obsitle, moditle, linitle, smitle
      endif
 

c*****begin with a default window
      call sm_location (3500,31000,4000,30000)
      call sm_window (1,1,1,1,1,1)
      call sm_limits (0.0,1.0,0.0,1.0)
      call defcolor (1)


c*****write smoothing information at the top of the plot
      call sm_lweight (2.2)
      call sm_expand (0.7)
      call sm_relocate (-0.120,1.015)
      call sm_label (smitle)


      if (isoitle(1:10) .eq. '          ') then
         isoitle(1:16) = 'no isotopic data'
      endif
      call sm_relocate (-0.120,1.075)
      call sm_label (isoitle(1:120))
      if (numiso .gt. 3) then
         call sm_relocate (-0.120,1.045)
         call sm_label (isoitle(121:240))
      endif
      if (control .eq. 'gridplo' .or.
     .    control .eq. 'gridsyn' .or.
     .    control .eq. 'gridend') then
         write (nf6out,3002) isoitle(1:120)
         write (nf6out,3002) isoitle(121:240)
      endif
 

c*****define the real plot limits
      if (xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the spectra
      call defcolor (1)
      if (whichwin .eq. '1of1') then
         idev = 1
         call sm_window (1,1,1,1,1,1)
      else
         idev = 2
         call sm_defvar ('y_gutter','0.0')
         call sm_window (1,2,1,1,1,1)
      endif
      call sm_lweight (4.0)
      call sm_expand (1.2)
      call sm_box (0,0,0,0)
      call sm_lweight (2.0)
      call sm_expand (0.8)
      call sm_box (1,2,4,4)
      if (iflip .eq. 1) then
         array = 'Wavenumber'
      else
         array = 'Wavelength'
      endif
      call sm_xlabel (array)
      array = 'Rel  Flux'
      call sm_ylabel (array)


c*****plot the synthetic spectra
      call sm_lweight (2.2)
      call sm_expand (0.7)
      do i=1,100
         if (pec(i) .ne. 0) go to 111
      enddo            
111   do j=1,nsyn
         if (choice.eq.'h' .or. choice.eq.'f' .or.
     .       choice.eq.'g') then
            call defcolor (8)
            call sm_ltype (j-1)
         else
            if (smterm(1:3) .eq. 'x11') then
               call defcolor (j+1)
               call sm_ltype (0)
            else
               call defcolor (1)
               call sm_ltype (j-1)
            endif
         endif
         call sm_connect (xsyn,chunk(1,j),kount) 
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.045*(xlo-xhi),
     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
            call sm_draw (xhi+0.005*(xlo-xhi),
     .                 ylo+(0.12+0.06*j)*(yhi-ylo))
            call sm_relocate (xhi+0.05*(xlo-xhi),
     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
         else
            call sm_relocate (xlo+0.045*(xhi-xlo),
     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
            call sm_draw (xlo+0.005*(xlo-xhi),
     .                 ylo+(0.12+0.06*j)*(yhi-ylo))
            call sm_relocate (xlo+0.05*(xhi-xlo),
     .                     ylo+(0.12+0.06*j)*(yhi-ylo))
         endif
         noff = 80*(j-1)
         call sm_lweight (2.2)
         call sm_label (abitle(noff+1:noff+80))
         if ((control .eq. 'gridplo' .or.
     .        control .eq. 'gridsyn' .or.
     .        control .eq. 'gridend') .and. 
     .        whichwin.eq.'1of1') then
            write (nf6out,3002) abitle(noff+1:noff+80)
         endif
      enddo
      call defcolor (1)
      call sm_ltype (0)

   
c*****plot the observed spectrum
      if (plotopt .eq. 2) then
         call defcolor (1)
         if (choice.eq.'h' .or. choice.eq.'f' .or.
     .       choice.eq.'g') then
            call sm_lweight (4.0)
         else 
            call sm_lweight (2.2)
         endif
         call sm_ltype (0)
         call sm_expand (3.0)
         style(1) = 43.5
         call sm_ptype (style,1)
         mount = lim2obs - lim1obs + 1
         if (mount .lt. 500) then
            call sm_points (xobs(lim1obs),yobs(lim1obs),mount)
         else
            if (histoyes .eq. 1) then
               call sm_histogram (xobs(lim1obs),yobs(lim1obs),mount)
            else
               call sm_connect (xobs(lim1obs),yobs(lim1obs),mount)
            endif
         endif
         call sm_lweight (2.2)
         call sm_expand (0.7)
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.05*(xlo-xhi),ylo+0.12*(yhi-ylo))
         else
            call sm_relocate (xlo+0.05*(xhi-xlo),ylo+0.12*(yhi-ylo))
         endif
         call sm_label (obsitle)
      endif
      if (iflip .eq. 1) then
         call sm_relocate (xhi+0.05*(xlo-xhi),ylo+0.06*(yhi-ylo))
      else
         call sm_relocate (xlo+0.05*(xhi-xlo),ylo+0.06*(yhi-ylo))
      endif
      call sm_label (moditle)
      if (whichwin.eq.'1of1' .or. plotopt.ne.2) then
         return
      endif


c*****this section of code is executed only if a deviations plot is desired;
c     find the starting and stopping points in the arrays for the deviations
      if (xsyn(kount) .le. xobs(lim1obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim2obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim1obs)) go to 150
      lim3obs = lim1obs
      do k=2,kount
         if (xsyn(k) .gt. xobs(lim3obs)) then
            lim1syn = k - 1
            go to 155
         endif
      enddo
150   lim1syn = 1
      do l=lim1obs,lim2obs
         if (xsyn(lim1syn) .le. xobs(l)) then
            lim3obs = l 
            go to 155
         endif
      enddo
155   if (xsyn(kount) .lt. xobs(lim2obs)) go to 160
      lim4obs = lim2obs
      do k=lim1syn,kount
         if (xsyn(k) .gt. xobs(lim4obs)) then
            lim2syn = k
            go to 165
         endif
      enddo
160   lim2syn = kount
      do l=lim3obs,lim2obs
         if (xsyn(lim2syn) .lt. xobs(l)) then
            lim4obs = l - 1
            go to 165
         endif
      enddo


c  compute the deviations; linear interpolation in the wavelength array
c  of the synthetic spectra is considered sufficient
165   do j=1,nsyn
         lpoint = lim1syn
         devsigma = 0.
         do i=lim3obs,lim4obs
170         if (xsyn(lpoint+1) .lt. xobs(i)) then
               lpoint = lpoint + 1
               go to 170
            endif
            syninterp = (chunk(lpoint+1,j)-chunk(lpoint,j))*
     .         (xobs(i)-xsyn(lpoint))/(xsyn(lpoint+1)-xsyn(lpoint)) +
     .         chunk(lpoint,j)
            dev(i) = yobs(i) - syninterp
            devsigma = devsigma + dev(i)**2
         enddo
         devsigma = dsqrt(devsigma/(lim4obs-lim3obs-1))
         
      
c  from first set of deviations, define the plot limits, draw and label box
         if (j .eq. 1) then
            yup = -1000.
            ydown = +1000.
            do i=lim3obs,lim4obs
               yup = amax1(yup,dev(i))
               ydown = amin1(ydown,dev(i))
            enddo
            ydelta = amin1(0.3,amax1(0.05,1.5*(yup-ydown)/2.))
            ydown = -ydelta
            yup = ydelta
            call sm_defvar ('y_gutter','0.0')
            call sm_window (1,2,1,2,1,2)
            call sm_limits (xlo,xhi,ydown,yup)
            call findtic (ydown,yup,bigytic,smlytic)
            call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
            call sm_lweight (4.0)
            call sm_expand (1.2)
            call defcolor (1)
            call sm_box (0,0,0,0)
            call sm_lweight (2.0)
            call sm_expand (0.8)
            call sm_box (4,2,4,4)
            array = 'Obs - Comp'
            call sm_ylabel (array)
            call sm_relocate (xlo,0.0)
            call sm_draw (xhi,0.0)
         endif


c  plot the array of deviations
         if (choice.eq.'h' .or. choice.eq.'f' .or.
     .       choice.eq.'g') then
            call defcolor (8)
            call sm_ltype (j-1)
         else
            if (smterm(1:3) .eq. 'x11') then
               call defcolor (j+1)
               call sm_ltype (0)
            else
               call defcolor (1)
               call sm_ltype (j-1)
            endif
         endif
         call defcolor (j+1)
         call sm_lweight (2.2)
         call sm_connect (xobs(lim1obs),dev(lim1obs),mount)
         write (array,1021) devsigma
         call sm_relocate(xhi-0.2*(xhi-xlo),
     .                 ydown+(0.10+0.06*j)*(yup-ydown))
         call sm_relocate(xhi-0.24*(xhi-xlo),
     .                 ydown+(0.10+0.06*j)*(yup-ydown))
         call sm_draw(xhi-0.215*(xhi-xlo),
     .                 ydown+(0.10+0.06*j)*(yup-ydown))
         call sm_label (array)
         if (choice .eq. 'g') then
            noff = 80*(j-1)
            write (nf6out,3002) abitle(noff+1:noff+80)
            write (nf6out,3003) devsigma, velsh
         endif
      enddo


c  reset the spectrum plot boundaries before exiting
      if(xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif
1000  return


c*****format statements
1021  format ('sigma =',f7.4)
3001  format (/'RUN NUMBER:', i4, 65('-'))
3002  format (a80)
3003  format ('sigma =',f8.5, '   lambda shift =',f7.3,' km/s')


      end
